/* ImapDialog.c generated by valac 0.55.1, the Vala compiler
 * generated from ImapDialog.vala, do not modify */

/*
* Copyright 2020-2021 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
*/

#include "online-accounts.h"
#include <gio/gio.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <libedataserver/libedataserver.h>
#include <glib/gi18n-lib.h>
#include <camel/camel.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <handy.h>
#include <gdk/gdk.h>

enum  {
	ONLINE_ACCOUNTS_IMAP_DIALOG_0_PROPERTY,
	ONLINE_ACCOUNTS_IMAP_DIALOG_NUM_PROPERTIES
};
static GParamSpec* online_accounts_imap_dialog_properties[ONLINE_ACCOUNTS_IMAP_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_ENamedParameters_free0(var) ((var == NULL) ? NULL : (var = (_vala_ENamedParameters_free (var), NULL)))
typedef struct _OnlineAccountsImapDialogLoadConfigurationData OnlineAccountsImapDialogLoadConfigurationData;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _OnlineAccountsImapDialogSaveConfigurationData OnlineAccountsImapDialogSaveConfigurationData;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _OnlineAccountsImapDialogPrivate {
	GCancellable* cancellable;
	GraniteValidatedEntry* imap_server_entry;
	GraniteValidatedEntry* imap_username_entry;
	GraniteValidatedEntry* smtp_server_entry;
	GtkButton* save_button;
	GtkCheckButton* use_imap_credentials;
	GtkCheckButton* smtp_no_credentials;
	GtkComboBoxText* imap_encryption_combobox;
	GtkComboBoxText* smtp_encryption_combobox;
	GtkEntry* smtp_password_entry;
	GtkEntry* smtp_username_entry;
	GtkSpinButton* imap_port_spin;
	GtkSpinButton* smtp_port_spin;
	OnlineAccountsImapLoginPage* login_page;
	OnlineAccountsImapSavePage* save_page;
	guint cancel_timeout_id;
	ESourceRegistry* registry;
	ESource* source;
};

struct _OnlineAccountsImapDialogLoadConfigurationData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	OnlineAccountsImapDialog* self;
	ESource* account_source;
	GCancellable* cancellable;
	GError* _tmp0_;
	ESourceRegistry* _tmp1_;
	ESourceRegistry* _tmp2_;
	ESourceRegistry* _tmp3_;
	ESource* _tmp4_;
	ESourceCredentialsProvider* credentials_provider;
	ESourceRegistry* _tmp5_;
	ESourceCredentialsProvider* _tmp6_;
	ENamedParameters* account_credentials;
	ESourceCredentialsProvider* _tmp7_;
	ENamedParameters* _tmp8_;
	ENamedParameters* _tmp9_;
	OnlineAccountsImapLoginPage* _tmp10_;
	ENamedParameters* _tmp11_;
	const gchar* _tmp12_;
	ESourceMailAccount* account_extension;
	ESourceExtension* _tmp13_;
	ESourceMailAccount* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	ESource* identity_source;
	ESourceRegistry* _tmp17_;
	ESourceMailAccount* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	ESource* _tmp21_;
	ESource* _tmp22_;
	ESource* _tmp23_;
	ESourceMailIdentity* identity_extension;
	ESource* _tmp24_;
	ESourceExtension* _tmp25_;
	OnlineAccountsImapLoginPage* _tmp26_;
	ESourceMailIdentity* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	OnlineAccountsImapLoginPage* _tmp30_;
	ESourceMailIdentity* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	ESource* _tmp34_;
	ESourceMailSubmission* submission_extension;
	ESource* _tmp35_;
	ESourceExtension* _tmp36_;
	ESourceMailSubmission* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	ESource* transport_source;
	ESourceRegistry* _tmp40_;
	ESourceMailSubmission* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	ESource* _tmp44_;
	ESource* _tmp45_;
	ESource* _tmp46_;
	ESourceSecurity* transport_security_extension;
	ESource* _tmp47_;
	ESourceExtension* _tmp48_;
	GtkComboBoxText* _tmp49_;
	ESourceSecurity* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	ESource* _tmp53_;
	ESourceAuthentication* transport_auth_extension;
	ESource* _tmp54_;
	ESourceExtension* _tmp55_;
	GtkEntry* _tmp56_;
	ESourceAuthentication* _tmp57_;
	const gchar* _tmp58_;
	const gchar* _tmp59_;
	GraniteValidatedEntry* _tmp60_;
	ESourceAuthentication* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	GtkSpinButton* _tmp64_;
	ESourceAuthentication* _tmp65_;
	guint _tmp66_;
	guint _tmp67_;
	ENamedParameters* transport_credentials;
	ESourceCredentialsProvider* _tmp68_;
	ESource* _tmp69_;
	ENamedParameters* _tmp70_;
	ENamedParameters* _tmp71_;
	GtkCheckButton* _tmp72_;
	gboolean _tmp73_;
	ENamedParameters* _tmp74_;
	ENamedParameters* _tmp75_;
	const gchar* _tmp76_;
	ENamedParameters* _tmp77_;
	const gchar* _tmp78_;
	GtkCheckButton* _tmp79_;
	GtkCheckButton* _tmp80_;
	GtkEntry* _tmp81_;
	ENamedParameters* _tmp82_;
	const gchar* _tmp83_;
	ESourceSecurity* account_security_extension;
	ESourceExtension* _tmp84_;
	GtkComboBoxText* _tmp85_;
	ESourceSecurity* _tmp86_;
	const gchar* _tmp87_;
	const gchar* _tmp88_;
	ESourceAuthentication* account_auth_extension;
	ESourceExtension* _tmp89_;
	GraniteValidatedEntry* _tmp90_;
	ESourceAuthentication* _tmp91_;
	const gchar* _tmp92_;
	const gchar* _tmp93_;
	GraniteValidatedEntry* _tmp94_;
	ESourceAuthentication* _tmp95_;
	const gchar* _tmp96_;
	const gchar* _tmp97_;
	GtkSpinButton* _tmp98_;
	ESourceAuthentication* _tmp99_;
	guint _tmp100_;
	guint _tmp101_;
	const gchar* _tmp102_;
	const gchar* _tmp103_;
	OnlineAccountsImapLoginPage* _tmp104_;
	const gchar* _tmp105_;
	const gchar* _tmp106_;
	GError* _inner_error0_;
};

struct _OnlineAccountsImapDialogSaveConfigurationData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	OnlineAccountsImapDialog* self;
	ESourceRegistry* _tmp0_;
	ESourceRegistry* _tmp1_;
	GCancellable* _tmp2_;
	ESourceRegistry* _tmp3_;
	ESourceRegistry* _tmp4_;
	GCancellable* _tmp5_;
	ESource* account_source;
	ESource* identity_source;
	ESource* transport_source;
	ESource* _tmp6_;
	ESource* _tmp7_;
	ESource* _tmp8_;
	ESource* _tmp9_;
	ESourceMailAccount* account_extension;
	ESource* _tmp10_;
	ESourceExtension* _tmp11_;
	ESourceMailAccount* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	ESourceRegistry* _tmp15_;
	ESourceMailAccount* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	ESource* _tmp19_;
	gboolean _tmp20_;
	ESource* _tmp21_;
	ESource* _tmp22_;
	ESourceMailSubmission* submission_extension;
	ESource* _tmp23_;
	ESourceExtension* _tmp24_;
	ESourceMailSubmission* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	ESourceRegistry* _tmp28_;
	ESourceMailSubmission* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	ESource* _tmp32_;
	ESource* _tmp33_;
	ESource* _tmp34_;
	gchar* _tmp35_;
	ESource* _tmp36_;
	ESource* _tmp37_;
	ESource* _tmp38_;
	ESource* _tmp39_;
	ESource* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	ESource* _tmp44_;
	ESource* _tmp45_;
	ESource* _tmp46_;
	ESource* _tmp47_;
	ESource* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	gchar* _tmp51_;
	ESource* _tmp52_;
	ESource* _tmp53_;
	ESource* _tmp54_;
	ESource* _tmp55_;
	ESource* _tmp56_;
	OnlineAccountsImapLoginPage* _tmp57_;
	const gchar* _tmp58_;
	const gchar* _tmp59_;
	ESourceMailAccount* _vala1_account_extension;
	ESource* _tmp60_;
	ESourceExtension* _tmp61_;
	ESourceMailAccount* _tmp62_;
	ESource* _tmp63_;
	const gchar* _tmp64_;
	const gchar* _tmp65_;
	ESourceMailAccount* _tmp66_;
	ESourceMailAccount* _tmp67_;
	ESourceSecurity* account_security_extension;
	ESource* _tmp68_;
	ESourceExtension* _tmp69_;
	ESourceSecurity* _tmp70_;
	GtkComboBoxText* _tmp71_;
	const gchar* _tmp72_;
	const gchar* _tmp73_;
	ESourceAuthentication* account_auth_extension;
	ESource* _tmp74_;
	ESourceExtension* _tmp75_;
	ESourceAuthentication* _tmp76_;
	GraniteValidatedEntry* _tmp77_;
	const gchar* _tmp78_;
	const gchar* _tmp79_;
	ESourceAuthentication* _tmp80_;
	GtkSpinButton* _tmp81_;
	gdouble _tmp82_;
	gdouble _tmp83_;
	ESourceAuthentication* _tmp84_;
	GraniteValidatedEntry* _tmp85_;
	const gchar* _tmp86_;
	const gchar* _tmp87_;
	ESourceRefresh* refresh_extension;
	ESource* _tmp88_;
	ESourceExtension* _tmp89_;
	ESourceRefresh* _tmp90_;
	ESourceRefresh* _tmp91_;
	ESourceMailSubmission* _vala1_submission_extension;
	ESource* _tmp92_;
	ESourceExtension* _tmp93_;
	ESourceMailSubmission* _tmp94_;
	ESource* _tmp95_;
	const gchar* _tmp96_;
	const gchar* _tmp97_;
	ESourceMailIdentity* identity_extension;
	ESource* _tmp98_;
	ESourceExtension* _tmp99_;
	ESourceMailIdentity* _tmp100_;
	OnlineAccountsImapLoginPage* _tmp101_;
	const gchar* _tmp102_;
	const gchar* _tmp103_;
	ESourceMailIdentity* _tmp104_;
	OnlineAccountsImapLoginPage* _tmp105_;
	const gchar* _tmp106_;
	const gchar* _tmp107_;
	ESourceMailComposition* composition_extension;
	ESource* _tmp108_;
	ESourceExtension* _tmp109_;
	ESourceMailTransport* transport_extension;
	ESource* _tmp110_;
	ESourceExtension* _tmp111_;
	ESourceMailTransport* _tmp112_;
	ESourceSecurity* transport_security_extension;
	ESource* _tmp113_;
	ESourceExtension* _tmp114_;
	ESourceSecurity* _tmp115_;
	GtkComboBoxText* _tmp116_;
	const gchar* _tmp117_;
	const gchar* _tmp118_;
	ESourceAuthentication* transport_auth_extension;
	ESource* _tmp119_;
	ESourceExtension* _tmp120_;
	ESourceAuthentication* _tmp121_;
	GraniteValidatedEntry* _tmp122_;
	const gchar* _tmp123_;
	const gchar* _tmp124_;
	ESourceAuthentication* _tmp125_;
	GtkSpinButton* _tmp126_;
	gdouble _tmp127_;
	gdouble _tmp128_;
	ESourceAuthentication* _tmp129_;
	GtkEntry* _tmp130_;
	const gchar* _tmp131_;
	const gchar* _tmp132_;
	OnlineAccountsCamelSession* session;
	OnlineAccountsCamelSession* _tmp133_;
	CamelService* imap_service;
	OnlineAccountsCamelSession* _tmp134_;
	ESource* _tmp135_;
	const gchar* _tmp136_;
	const gchar* _tmp137_;
	ESourceMailAccount* _tmp138_;
	const gchar* _tmp139_;
	const gchar* _tmp140_;
	CamelService* _tmp141_;
	CamelService* _tmp142_;
	OnlineAccountsImapLoginPage* _tmp143_;
	const gchar* _tmp144_;
	const gchar* _tmp145_;
	ESource* _tmp146_;
	CamelService* _tmp147_;
	CamelService* _tmp148_;
	CamelService* _tmp149_;
	GCancellable* _tmp150_;
	GList* imap_auth_types;
	CamelService* _tmp151_;
	GCancellable* _tmp152_;
	GList* _tmp153_;
	GError* imap_auth_error;
	GList* _tmp154_;
	GList* imap_auth_type_collection;
	GList* imap_auth_type_it;
	CamelServiceAuthType* imap_auth_type;
	CamelServiceAuthType* _tmp155_;
	const gchar* _tmp156_;
	ESourceAuthentication* _tmp157_;
	CamelServiceAuthType* _tmp158_;
	const gchar* _tmp159_;
	ESource* _tmp160_;
	CamelService* _tmp161_;
	GCancellable* imap_auth_cancellable;
	GCancellable* _tmp162_;
	GCancellable* _tmp163_;
	CamelService* _tmp164_;
	CamelService* _tmp165_;
	GCancellable* _tmp166_;
	CamelService* _tmp167_;
	GCancellable* _tmp168_;
	CamelServiceAuthType* _tmp169_;
	const gchar* _tmp170_;
	GError* e;
	CamelServiceAuthType* _tmp171_;
	const gchar* _tmp172_;
	GError* _tmp173_;
	const gchar* _tmp174_;
	GError* _tmp175_;
	GError* _tmp176_;
	GError* _tmp177_;
	GError* _tmp178_;
	GError* _tmp179_;
	GError* _tmp180_;
	const gchar* _tmp181_;
	gchar* _tmp182_;
	gchar* _tmp183_;
	GError* _tmp184_;
	GError* _tmp185_;
	CamelService* _tmp186_;
	CamelStore* imap_store;
	CamelService* _tmp187_;
	CamelStore* _tmp188_;
	GHashTable* save_setup;
	CamelStore* _tmp189_;
	GCancellable* _tmp190_;
	GHashTable* _tmp191_;
	GHashTable* _tmp192_;
	gchar* encoded_account_uri;
	ESource* _tmp193_;
	const gchar* _tmp194_;
	const gchar* _tmp195_;
	gchar* _tmp196_;
	GHashTable* _tmp197_;
	GList* _tmp198_;
	GList* key_collection;
	GList* key_it;
	const gchar* key;
	gchar** keys;
	const gchar* _tmp199_;
	gchar** _tmp200_;
	gchar** _tmp201_;
	gint keys_length1;
	gint _keys_size_;
	gboolean _tmp202_;
	gchar** _tmp203_;
	gint _tmp203__length1;
	gchar** _tmp204_;
	gint _tmp204__length1;
	gchar** _tmp205_;
	gint _tmp205__length1;
	const gchar* _tmp206_;
	gchar* save_setup_source_type;
	gchar** _tmp207_;
	gint _tmp207__length1;
	const gchar* _tmp208_;
	gchar* _tmp209_;
	gchar* save_setup_extension_name;
	gchar** _tmp210_;
	gint _tmp210__length1;
	const gchar* _tmp211_;
	gchar* _tmp212_;
	gchar* save_setup_property_name;
	gchar** _tmp213_;
	gint _tmp213__length1;
	const gchar* _tmp214_;
	gchar* _tmp215_;
	const gchar* _tmp216_;
	const gchar* _tmp217_;
	GQuark _tmp219_;
	gboolean _tmp220_;
	const gchar* _tmp221_;
	const gchar* _tmp222_;
	ESourceMailAccount* _tmp223_;
	const gchar* _tmp224_;
	GHashTable* _tmp225_;
	const gchar* _tmp226_;
	gconstpointer _tmp227_;
	gchar* _tmp228_;
	gchar* _tmp229_;
	gchar* _tmp230_;
	gchar* _tmp231_;
	gboolean _tmp232_;
	const gchar* _tmp233_;
	const gchar* _tmp234_;
	ESourceMailComposition* _tmp235_;
	const gchar* _tmp236_;
	GHashTable* _tmp237_;
	const gchar* _tmp238_;
	gconstpointer _tmp239_;
	gchar* _tmp240_;
	gchar* _tmp241_;
	gchar* _tmp242_;
	gchar* _tmp243_;
	gboolean _tmp244_;
	const gchar* _tmp245_;
	const gchar* _tmp246_;
	ESourceMailSubmission* _tmp247_;
	const gchar* _tmp248_;
	GHashTable* _tmp249_;
	const gchar* _tmp250_;
	gconstpointer _tmp251_;
	gchar* _tmp252_;
	gchar* _tmp253_;
	gchar* _tmp254_;
	gchar* _tmp255_;
	const gchar* _tmp256_;
	ESourceMailAccount* _tmp257_;
	GError* _vala1_e;
	GError* _tmp258_;
	const gchar* _tmp259_;
	GCancellable* _tmp260_;
	CamelService* transport_service;
	OnlineAccountsCamelSession* _tmp261_;
	ESource* _tmp262_;
	const gchar* _tmp263_;
	const gchar* _tmp264_;
	ESourceMailTransport* _tmp265_;
	const gchar* _tmp266_;
	const gchar* _tmp267_;
	CamelService* _tmp268_;
	ESource* _tmp269_;
	CamelService* _tmp270_;
	GtkCheckButton* _tmp271_;
	gboolean _tmp272_;
	gboolean _tmp273_;
	GtkCheckButton* _tmp274_;
	gboolean _tmp275_;
	gboolean _tmp276_;
	CamelService* _tmp277_;
	OnlineAccountsImapLoginPage* _tmp278_;
	const gchar* _tmp279_;
	const gchar* _tmp280_;
	CamelService* _tmp281_;
	GtkEntry* _tmp282_;
	const gchar* _tmp283_;
	const gchar* _tmp284_;
	CamelService* _tmp285_;
	CamelService* _tmp286_;
	GCancellable* _tmp287_;
	GList* smtp_auth_types;
	CamelService* _tmp288_;
	GCancellable* _tmp289_;
	GList* _tmp290_;
	GError* smtp_auth_error;
	GList* _tmp291_;
	GList* smtp_auth_type_collection;
	GList* smtp_auth_type_it;
	CamelServiceAuthType* smtp_auth_type;
	CamelServiceAuthType* _tmp292_;
	const gchar* _tmp293_;
	ESourceAuthentication* _tmp294_;
	CamelServiceAuthType* _tmp295_;
	const gchar* _tmp296_;
	ESource* _tmp297_;
	CamelService* _tmp298_;
	GCancellable* smtp_auth_cancellable;
	GCancellable* _tmp299_;
	GCancellable* _tmp300_;
	CamelService* _tmp301_;
	GCancellable* _tmp302_;
	CamelServiceAuthType* _tmp303_;
	const gchar* _tmp304_;
	GError* _vala2_e;
	CamelServiceAuthType* _tmp305_;
	const gchar* _tmp306_;
	GError* _tmp307_;
	const gchar* _tmp308_;
	GError* _tmp309_;
	GError* _tmp310_;
	GError* _tmp311_;
	GError* _tmp312_;
	GError* _tmp313_;
	GError* _tmp314_;
	const gchar* _tmp315_;
	gchar* _tmp316_;
	gchar* _tmp317_;
	GError* _tmp318_;
	GError* _tmp319_;
	GCancellable* _tmp320_;
	ESource* _tmp321_;
	OnlineAccountsImapLoginPage* _tmp322_;
	const gchar* _tmp323_;
	const gchar* _tmp324_;
	GCancellable* _tmp325_;
	GtkCheckButton* _tmp326_;
	gboolean _tmp327_;
	gboolean _tmp328_;
	ESource* _tmp329_;
	OnlineAccountsImapLoginPage* _tmp330_;
	const gchar* _tmp331_;
	const gchar* _tmp332_;
	GCancellable* _tmp333_;
	ESource* _tmp334_;
	GtkEntry* _tmp335_;
	const gchar* _tmp336_;
	const gchar* _tmp337_;
	GCancellable* _tmp338_;
	ESourceRegistry* _tmp339_;
	ESource* _tmp340_;
	GCancellable* _tmp341_;
	ESourceRegistry* _tmp342_;
	ESource* _tmp343_;
	GCancellable* _tmp344_;
	ESourceRegistry* _tmp345_;
	ESource* _tmp346_;
	GCancellable* _tmp347_;
	GError* _inner_error0_;
};

struct _Block5Data {
	int _ref_count_;
	OnlineAccountsImapDialog* self;
	GCancellable* cancellable;
};

struct _Block6Data {
	int _ref_count_;
	OnlineAccountsImapDialog* self;
	GtkRevealer* smtp_revealer;
	GtkGrid* main_grid;
	HdyDeck* deck;
};

static gint OnlineAccountsImapDialog_private_offset;
static gpointer online_accounts_imap_dialog_parent_class = NULL;

static void online_accounts_imap_dialog_set_button_sensitivity (OnlineAccountsImapDialog* self);
static void online_accounts_imap_dialog_load_configuration_data_free (gpointer _data);
static gboolean online_accounts_imap_dialog_load_configuration_co (OnlineAccountsImapDialogLoadConfigurationData* _data_);
static void online_accounts_imap_dialog_load_configuration_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void _vala_ENamedParameters_free (ENamedParameters* self);
static void online_accounts_imap_dialog_save_configuration_data_free (gpointer _data);
static void online_accounts_imap_dialog_save_configuration (OnlineAccountsImapDialog* self,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static void online_accounts_imap_dialog_save_configuration_finish (OnlineAccountsImapDialog* self,
                                                            GAsyncResult* _res_,
                                                            GError** error);
static gboolean online_accounts_imap_dialog_save_configuration_co (OnlineAccountsImapDialogSaveConfigurationData* _data_);
static void online_accounts_imap_dialog_save_configuration_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void online_accounts_imap_dialog_set_cancel_timeout (OnlineAccountsImapDialog* self,
                                                     GCancellable* cancellable);
static void online_accounts_imap_dialog_unset_cancel_timeout (OnlineAccountsImapDialog* self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean __lambda25_ (Block5Data* _data5_);
static gboolean ___lambda25__gsource_func (gpointer self);
static GObject * online_accounts_imap_dialog_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void _gtk_widget_destroy_online_accounts_imap_login_page_cancel (OnlineAccountsImapLoginPage* _sender,
                                                                 gpointer self);
static void _online_accounts_imap_dialog___lambda26_ (Block6Data* _data6_);
static void __online_accounts_imap_dialog___lambda26__gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void _gtk_widget_destroy_online_accounts_imap_save_page_close (OnlineAccountsImapSavePage* _sender,
                                                               gpointer self);
static void _online_accounts_imap_dialog___lambda27_ (Block6Data* _data6_);
static void __online_accounts_imap_dialog___lambda27__online_accounts_imap_save_page_back (OnlineAccountsImapSavePage* _sender,
                                                                                    gpointer self);
static void _online_accounts_imap_dialog___lambda28_ (Block6Data* _data6_);
static void __online_accounts_imap_dialog___lambda28__gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void _online_accounts_imap_dialog___lambda29_ (Block6Data* _data6_);
static void __online_accounts_imap_dialog___lambda29__g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void _online_accounts_imap_dialog___lambda30_ (OnlineAccountsImapDialog* self);
static void __online_accounts_imap_dialog___lambda30__g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void _online_accounts_imap_dialog___lambda31_ (OnlineAccountsImapDialog* self);
static void __online_accounts_imap_dialog___lambda31__gtk_editable_changed (GtkEditable* _sender,
                                                                     gpointer self);
static void _online_accounts_imap_dialog___lambda32_ (OnlineAccountsImapDialog* self);
static void __online_accounts_imap_dialog___lambda32__gtk_editable_changed (GtkEditable* _sender,
                                                                     gpointer self);
static void _online_accounts_imap_dialog___lambda33_ (OnlineAccountsImapDialog* self);
static void __online_accounts_imap_dialog___lambda33__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                      gpointer self);
static void _online_accounts_imap_dialog___lambda34_ (OnlineAccountsImapDialog* self);
static void __online_accounts_imap_dialog___lambda34__gtk_editable_changed (GtkEditable* _sender,
                                                                     gpointer self);
static void _online_accounts_imap_dialog___lambda35_ (OnlineAccountsImapDialog* self);
static void __online_accounts_imap_dialog___lambda35__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                      gpointer self);
static void _online_accounts_imap_dialog___lambda36_ (Block6Data* _data6_);
static void __lambda37_ (OnlineAccountsImapDialog* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda37__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __online_accounts_imap_dialog___lambda36__gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static gboolean _online_accounts_imap_dialog___lambda38_ (OnlineAccountsImapDialog* self,
                                                   GdkEventKey* event_key);
static gboolean __online_accounts_imap_dialog___lambda38__gtk_widget_key_release_event (GtkWidget* _sender,
                                                                                 GdkEventKey* event,
                                                                                 gpointer self);
static void online_accounts_imap_dialog_finalize (GObject * obj);
static GType online_accounts_imap_dialog_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
online_accounts_imap_dialog_get_instance_private (OnlineAccountsImapDialog* self)
{
	return G_STRUCT_MEMBER_P (self, OnlineAccountsImapDialog_private_offset);
}

static void
online_accounts_imap_dialog_set_button_sensitivity (OnlineAccountsImapDialog* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GraniteValidatedEntry* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkButton* _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp2_ = self->priv->imap_username_entry;
	_tmp3_ = granite_validated_entry_get_is_valid (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		GraniteValidatedEntry* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = self->priv->imap_server_entry;
		_tmp6_ = granite_validated_entry_get_is_valid (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp1_ = _tmp7_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GraniteValidatedEntry* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp8_ = self->priv->smtp_server_entry;
		_tmp9_ = granite_validated_entry_get_is_valid (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp0_ = _tmp10_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp11_ = self->priv->save_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, _tmp0_);
}

static void
online_accounts_imap_dialog_load_configuration_data_free (gpointer _data)
{
	OnlineAccountsImapDialogLoadConfigurationData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account_source);
	_g_object_unref0 (_data_->cancellable);
	_g_object_unref0 (_data_->self);
	g_slice_free (OnlineAccountsImapDialogLoadConfigurationData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
online_accounts_imap_dialog_load_configuration (OnlineAccountsImapDialog* self,
                                                ESource* account_source,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	OnlineAccountsImapDialogLoadConfigurationData* _data_;
	OnlineAccountsImapDialog* _tmp0_;
	ESource* _tmp1_;
	GCancellable* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (account_source != NULL);
	_data_ = g_slice_new0 (OnlineAccountsImapDialogLoadConfigurationData);
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, online_accounts_imap_dialog_load_configuration_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (account_source);
	_g_object_unref0 (_data_->account_source);
	_data_->account_source = _tmp1_;
	_tmp2_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp2_;
	online_accounts_imap_dialog_load_configuration_co (_data_);
}

void
online_accounts_imap_dialog_load_configuration_finish (OnlineAccountsImapDialog* self,
                                                       GAsyncResult* _res_,
                                                       GError** error)
{
	OnlineAccountsImapDialogLoadConfigurationData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

static void
online_accounts_imap_dialog_load_configuration_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	OnlineAccountsImapDialogLoadConfigurationData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	online_accounts_imap_dialog_load_configuration_co (_data_);
}

static void
_vala_ENamedParameters_free (ENamedParameters* self)
{
	g_boxed_free (e_named_parameters_get_type (), self);
}

static gboolean
online_accounts_imap_dialog_load_configuration_co (OnlineAccountsImapDialogLoadConfigurationData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (!e_source_has_extension (_data_->account_source, E_SOURCE_EXTENSION_MAIL_ACCOUNT)) {
		_data_->_tmp0_ = g_error_new_literal (CAMEL_ERROR, CAMEL_ERROR_GENERIC, _ ("The data provided does not seem to reflect a valid mail account."));
		_data_->_inner_error0_ = _data_->_tmp0_;
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_state_ = 1;
	e_source_registry_new (_data_->cancellable, online_accounts_imap_dialog_load_configuration_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp2_ = e_source_registry_new_finish (_data_->_res_, &_data_->_inner_error0_);
	_data_->_tmp1_ = _data_->_tmp2_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp3_ = _data_->_tmp1_;
	_data_->_tmp1_ = NULL;
	_g_object_unref0 (_data_->self->priv->registry);
	_data_->self->priv->registry = _data_->_tmp3_;
	if (g_cancellable_is_cancelled (_data_->cancellable)) {
		_g_object_unref0 (_data_->_tmp1_);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp4_ = _g_object_ref0 (_data_->account_source);
	_g_object_unref0 (_data_->self->priv->source);
	_data_->self->priv->source = _data_->_tmp4_;
	_data_->_tmp5_ = _data_->self->priv->registry;
	_data_->_tmp6_ = e_source_credentials_provider_new (_data_->_tmp5_);
	_data_->credentials_provider = _data_->_tmp6_;
	_data_->_tmp7_ = _data_->credentials_provider;
	_data_->_tmp8_ = NULL;
	e_source_credentials_provider_lookup_sync (_data_->_tmp7_, _data_->account_source, NULL, &_data_->_tmp8_, &_data_->_inner_error0_);
	__vala_ENamedParameters_free0 (_data_->account_credentials);
	_data_->account_credentials = _data_->_tmp8_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		__vala_ENamedParameters_free0 (_data_->account_credentials);
		_g_object_unref0 (_data_->credentials_provider);
		_g_object_unref0 (_data_->_tmp1_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp9_ = _data_->account_credentials;
	if (_data_->_tmp9_ != NULL) {
		_data_->_tmp10_ = _data_->self->priv->login_page;
		_data_->_tmp11_ = _data_->account_credentials;
		_data_->_tmp12_ = e_named_parameters_get (_data_->_tmp11_, E_SOURCE_CREDENTIAL_PASSWORD);
		online_accounts_imap_login_page_set_password (_data_->_tmp10_, _data_->_tmp12_);
	}
	_data_->_tmp13_ = e_source_get_extension (_data_->account_source, E_SOURCE_EXTENSION_MAIL_ACCOUNT);
	_data_->account_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, e_source_mail_account_get_type (), ESourceMailAccount);
	_data_->_tmp14_ = _data_->account_extension;
	_data_->_tmp15_ = e_source_mail_account_get_identity_uid (_data_->_tmp14_);
	_data_->_tmp16_ = _data_->_tmp15_;
	if (g_strcmp0 (_data_->_tmp16_, "") != 0) {
		_data_->_tmp17_ = _data_->self->priv->registry;
		_data_->_tmp18_ = _data_->account_extension;
		_data_->_tmp19_ = e_source_mail_account_get_identity_uid (_data_->_tmp18_);
		_data_->_tmp20_ = _data_->_tmp19_;
		_data_->_tmp21_ = e_source_registry_ref_source (_data_->_tmp17_, _data_->_tmp20_);
		_data_->identity_source = _data_->_tmp21_;
		_data_->_tmp22_ = _data_->identity_source;
		if (_data_->_tmp22_ != NULL) {
			_data_->_tmp23_ = _data_->identity_source;
			if (e_source_has_extension (_data_->_tmp23_, E_SOURCE_EXTENSION_MAIL_IDENTITY)) {
				_data_->_tmp24_ = _data_->identity_source;
				_data_->_tmp25_ = e_source_get_extension (_data_->_tmp24_, E_SOURCE_EXTENSION_MAIL_IDENTITY);
				_data_->identity_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp25_, e_source_mail_identity_get_type (), ESourceMailIdentity);
				_data_->_tmp26_ = _data_->self->priv->login_page;
				_data_->_tmp27_ = _data_->identity_extension;
				_data_->_tmp28_ = e_source_mail_identity_get_address (_data_->_tmp27_);
				_data_->_tmp29_ = _data_->_tmp28_;
				online_accounts_imap_login_page_set_email (_data_->_tmp26_, _data_->_tmp29_);
				_data_->_tmp30_ = _data_->self->priv->login_page;
				_data_->_tmp31_ = _data_->identity_extension;
				_data_->_tmp32_ = e_source_mail_identity_get_name (_data_->_tmp31_);
				_data_->_tmp33_ = _data_->_tmp32_;
				online_accounts_imap_login_page_set_real_name (_data_->_tmp30_, _data_->_tmp33_);
			}
			_data_->_tmp34_ = _data_->identity_source;
			if (e_source_has_extension (_data_->_tmp34_, E_SOURCE_EXTENSION_MAIL_SUBMISSION)) {
				_data_->_tmp35_ = _data_->identity_source;
				_data_->_tmp36_ = e_source_get_extension (_data_->_tmp35_, E_SOURCE_EXTENSION_MAIL_SUBMISSION);
				_data_->submission_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp36_, e_source_mail_submission_get_type (), ESourceMailSubmission);
				_data_->_tmp37_ = _data_->submission_extension;
				_data_->_tmp38_ = e_source_mail_submission_get_transport_uid (_data_->_tmp37_);
				_data_->_tmp39_ = _data_->_tmp38_;
				if (_data_->_tmp39_ != NULL) {
					_data_->_tmp40_ = _data_->self->priv->registry;
					_data_->_tmp41_ = _data_->submission_extension;
					_data_->_tmp42_ = e_source_mail_submission_get_transport_uid (_data_->_tmp41_);
					_data_->_tmp43_ = _data_->_tmp42_;
					_data_->_tmp44_ = e_source_registry_ref_source (_data_->_tmp40_, _data_->_tmp43_);
					_data_->transport_source = _data_->_tmp44_;
					_data_->_tmp45_ = _data_->transport_source;
					if (_data_->_tmp45_ != NULL) {
						_data_->_tmp46_ = _data_->transport_source;
						if (e_source_has_extension (_data_->_tmp46_, E_SOURCE_EXTENSION_SECURITY)) {
							_data_->_tmp47_ = _data_->transport_source;
							_data_->_tmp48_ = e_source_get_extension (_data_->_tmp47_, E_SOURCE_EXTENSION_SECURITY);
							_data_->transport_security_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp48_, e_source_security_get_type (), ESourceSecurity);
							_data_->_tmp49_ = _data_->self->priv->smtp_encryption_combobox;
							_data_->_tmp50_ = _data_->transport_security_extension;
							_data_->_tmp51_ = e_source_security_get_method (_data_->_tmp50_);
							_data_->_tmp52_ = _data_->_tmp51_;
							gtk_combo_box_set_active_id ((GtkComboBox*) _data_->_tmp49_, _data_->_tmp52_);
						}
						_data_->_tmp53_ = _data_->transport_source;
						if (e_source_has_extension (_data_->_tmp53_, E_SOURCE_EXTENSION_AUTHENTICATION)) {
							_data_->_tmp54_ = _data_->transport_source;
							_data_->_tmp55_ = e_source_get_extension (_data_->_tmp54_, E_SOURCE_EXTENSION_AUTHENTICATION);
							_data_->transport_auth_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp55_, e_source_authentication_get_type (), ESourceAuthentication);
							_data_->_tmp56_ = _data_->self->priv->smtp_username_entry;
							_data_->_tmp57_ = _data_->transport_auth_extension;
							_data_->_tmp58_ = e_source_authentication_get_user (_data_->_tmp57_);
							_data_->_tmp59_ = _data_->_tmp58_;
							gtk_entry_set_text (_data_->_tmp56_, _data_->_tmp59_);
							_data_->_tmp60_ = _data_->self->priv->smtp_server_entry;
							_data_->_tmp61_ = _data_->transport_auth_extension;
							_data_->_tmp62_ = e_source_authentication_get_host (_data_->_tmp61_);
							_data_->_tmp63_ = _data_->_tmp62_;
							gtk_entry_set_text ((GtkEntry*) _data_->_tmp60_, _data_->_tmp63_);
							_data_->_tmp64_ = _data_->self->priv->smtp_port_spin;
							_data_->_tmp65_ = _data_->transport_auth_extension;
							_data_->_tmp66_ = e_source_authentication_get_port (_data_->_tmp65_);
							_data_->_tmp67_ = _data_->_tmp66_;
							gtk_spin_button_set_value (_data_->_tmp64_, (gdouble) _data_->_tmp67_);
						}
						_data_->_tmp68_ = _data_->credentials_provider;
						_data_->_tmp69_ = _data_->transport_source;
						_data_->_tmp70_ = NULL;
						e_source_credentials_provider_lookup_sync (_data_->_tmp68_, _data_->_tmp69_, NULL, &_data_->_tmp70_, &_data_->_inner_error0_);
						__vala_ENamedParameters_free0 (_data_->transport_credentials);
						_data_->transport_credentials = _data_->_tmp70_;
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
							g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
							__vala_ENamedParameters_free0 (_data_->transport_credentials);
							_g_object_unref0 (_data_->transport_source);
							_g_object_unref0 (_data_->identity_source);
							__vala_ENamedParameters_free0 (_data_->account_credentials);
							_g_object_unref0 (_data_->credentials_provider);
							_g_object_unref0 (_data_->_tmp1_);
							g_object_unref (_data_->_async_result);
							return FALSE;
						}
						_data_->_tmp71_ = _data_->transport_credentials;
						if (_data_->_tmp71_ == NULL) {
							_data_->_tmp72_ = _data_->self->priv->smtp_no_credentials;
							gtk_toggle_button_set_active ((GtkToggleButton*) _data_->_tmp72_, TRUE);
						} else {
							_data_->_tmp74_ = _data_->account_credentials;
							if (_data_->_tmp74_ != NULL) {
								_data_->_tmp75_ = _data_->account_credentials;
								_data_->_tmp76_ = e_named_parameters_get (_data_->_tmp75_, E_SOURCE_CREDENTIAL_PASSWORD);
								_data_->_tmp77_ = _data_->transport_credentials;
								_data_->_tmp78_ = e_named_parameters_get (_data_->_tmp77_, E_SOURCE_CREDENTIAL_PASSWORD);
								_data_->_tmp73_ = g_strcmp0 (_data_->_tmp76_, _data_->_tmp78_) == 0;
							} else {
								_data_->_tmp73_ = FALSE;
							}
							if (_data_->_tmp73_) {
								_data_->_tmp79_ = _data_->self->priv->use_imap_credentials;
								gtk_toggle_button_set_active ((GtkToggleButton*) _data_->_tmp79_, TRUE);
							} else {
								_data_->_tmp80_ = _data_->self->priv->use_imap_credentials;
								gtk_toggle_button_set_active ((GtkToggleButton*) _data_->_tmp80_, FALSE);
								_data_->_tmp81_ = _data_->self->priv->smtp_password_entry;
								_data_->_tmp82_ = _data_->transport_credentials;
								_data_->_tmp83_ = e_named_parameters_get (_data_->_tmp82_, E_SOURCE_CREDENTIAL_PASSWORD);
								gtk_entry_set_text (_data_->_tmp81_, _data_->_tmp83_);
							}
						}
						__vala_ENamedParameters_free0 (_data_->transport_credentials);
					}
					_g_object_unref0 (_data_->transport_source);
				}
			}
		}
		_g_object_unref0 (_data_->identity_source);
	}
	if (e_source_has_extension (_data_->account_source, E_SOURCE_EXTENSION_SECURITY)) {
		_data_->_tmp84_ = e_source_get_extension (_data_->account_source, E_SOURCE_EXTENSION_SECURITY);
		_data_->account_security_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp84_, e_source_security_get_type (), ESourceSecurity);
		_data_->_tmp85_ = _data_->self->priv->imap_encryption_combobox;
		_data_->_tmp86_ = _data_->account_security_extension;
		_data_->_tmp87_ = e_source_security_get_method (_data_->_tmp86_);
		_data_->_tmp88_ = _data_->_tmp87_;
		gtk_combo_box_set_active_id ((GtkComboBox*) _data_->_tmp85_, _data_->_tmp88_);
	}
	if (e_source_has_extension (_data_->account_source, E_SOURCE_EXTENSION_AUTHENTICATION)) {
		_data_->_tmp89_ = e_source_get_extension (_data_->account_source, E_SOURCE_EXTENSION_AUTHENTICATION);
		_data_->account_auth_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp89_, e_source_authentication_get_type (), ESourceAuthentication);
		_data_->_tmp90_ = _data_->self->priv->imap_username_entry;
		_data_->_tmp91_ = _data_->account_auth_extension;
		_data_->_tmp92_ = e_source_authentication_get_user (_data_->_tmp91_);
		_data_->_tmp93_ = _data_->_tmp92_;
		gtk_entry_set_text ((GtkEntry*) _data_->_tmp90_, _data_->_tmp93_);
		_data_->_tmp94_ = _data_->self->priv->imap_server_entry;
		_data_->_tmp95_ = _data_->account_auth_extension;
		_data_->_tmp96_ = e_source_authentication_get_host (_data_->_tmp95_);
		_data_->_tmp97_ = _data_->_tmp96_;
		gtk_entry_set_text ((GtkEntry*) _data_->_tmp94_, _data_->_tmp97_);
		_data_->_tmp98_ = _data_->self->priv->imap_port_spin;
		_data_->_tmp99_ = _data_->account_auth_extension;
		_data_->_tmp100_ = e_source_authentication_get_port (_data_->_tmp99_);
		_data_->_tmp101_ = _data_->_tmp100_;
		gtk_spin_button_set_value (_data_->_tmp98_, (gdouble) _data_->_tmp101_);
	}
	_data_->_tmp102_ = e_source_get_display_name (_data_->account_source);
	_data_->_tmp103_ = _data_->_tmp102_;
	if (g_strcmp0 (_data_->_tmp103_, "") != 0) {
		_data_->_tmp104_ = _data_->self->priv->login_page;
		_data_->_tmp105_ = e_source_get_display_name (_data_->account_source);
		_data_->_tmp106_ = _data_->_tmp105_;
		online_accounts_imap_login_page_set_display_name (_data_->_tmp104_, _data_->_tmp106_);
	}
	__vala_ENamedParameters_free0 (_data_->account_credentials);
	_g_object_unref0 (_data_->credentials_provider);
	_g_object_unref0 (_data_->_tmp1_);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
online_accounts_imap_dialog_save_configuration_data_free (gpointer _data)
{
	OnlineAccountsImapDialogSaveConfigurationData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (OnlineAccountsImapDialogSaveConfigurationData, _data_);
}

static void
online_accounts_imap_dialog_save_configuration (OnlineAccountsImapDialog* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	OnlineAccountsImapDialogSaveConfigurationData* _data_;
	OnlineAccountsImapDialog* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (OnlineAccountsImapDialogSaveConfigurationData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, online_accounts_imap_dialog_save_configuration_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	online_accounts_imap_dialog_save_configuration_co (_data_);
}

static void
online_accounts_imap_dialog_save_configuration_finish (OnlineAccountsImapDialog* self,
                                                       GAsyncResult* _res_,
                                                       GError** error)
{
	OnlineAccountsImapDialogSaveConfigurationData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

static void
online_accounts_imap_dialog_save_configuration_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	OnlineAccountsImapDialogSaveConfigurationData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	online_accounts_imap_dialog_save_configuration_co (_data_);
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

static gboolean
online_accounts_imap_dialog_save_configuration_co (OnlineAccountsImapDialogSaveConfigurationData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		case 4:
		goto _state_4;
		case 5:
		goto _state_5;
		case 6:
		goto _state_6;
		case 7:
		goto _state_7;
		case 8:
		goto _state_8;
		case 9:
		goto _state_9;
		case 10:
		goto _state_10;
		case 11:
		goto _state_11;
		case 12:
		goto _state_12;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->registry;
	if (_data_->_tmp0_ == NULL) {
		_data_->_tmp2_ = _data_->self->priv->cancellable;
		_data_->_state_ = 1;
		e_source_registry_new (_data_->_tmp2_, online_accounts_imap_dialog_save_configuration_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp3_ = e_source_registry_new_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp1_ = _data_->_tmp3_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp4_ = _data_->_tmp1_;
		_data_->_tmp1_ = NULL;
		_g_object_unref0 (_data_->self->priv->registry);
		_data_->self->priv->registry = _data_->_tmp4_;
		_g_object_unref0 (_data_->_tmp1_);
	}
	_data_->_tmp5_ = _data_->self->priv->cancellable;
	if (g_cancellable_is_cancelled (_data_->_tmp5_)) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->account_source = NULL;
	_data_->identity_source = NULL;
	_data_->transport_source = NULL;
	_data_->_tmp6_ = _data_->self->priv->source;
	if (_data_->_tmp6_ != NULL) {
		_data_->_tmp7_ = _data_->self->priv->source;
		_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp7_);
		_g_object_unref0 (_data_->account_source);
		_data_->account_source = _data_->_tmp8_;
		_data_->_tmp9_ = _data_->account_source;
		if (!e_source_has_extension (_data_->_tmp9_, E_SOURCE_EXTENSION_MAIL_ACCOUNT)) {
			_data_->_tmp10_ = _data_->account_source;
			_data_->_tmp11_ = e_source_get_extension (_data_->_tmp10_, E_SOURCE_EXTENSION_MAIL_ACCOUNT);
			_data_->account_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, e_source_mail_account_get_type (), ESourceMailAccount);
			_data_->_tmp12_ = _data_->account_extension;
			_data_->_tmp13_ = e_source_mail_account_get_identity_uid (_data_->_tmp12_);
			_data_->_tmp14_ = _data_->_tmp13_;
			if (g_strcmp0 (_data_->_tmp14_, "") != 0) {
				_data_->_tmp15_ = _data_->self->priv->registry;
				_data_->_tmp16_ = _data_->account_extension;
				_data_->_tmp17_ = e_source_mail_account_get_identity_uid (_data_->_tmp16_);
				_data_->_tmp18_ = _data_->_tmp17_;
				_data_->_tmp19_ = e_source_registry_ref_source (_data_->_tmp15_, _data_->_tmp18_);
				_g_object_unref0 (_data_->identity_source);
				_data_->identity_source = _data_->_tmp19_;
				_data_->_tmp21_ = _data_->identity_source;
				if (_data_->_tmp21_ != NULL) {
					_data_->_tmp22_ = _data_->identity_source;
					_data_->_tmp20_ = e_source_has_extension (_data_->_tmp22_, E_SOURCE_EXTENSION_MAIL_SUBMISSION);
				} else {
					_data_->_tmp20_ = FALSE;
				}
				if (_data_->_tmp20_) {
					_data_->_tmp23_ = _data_->identity_source;
					_data_->_tmp24_ = e_source_get_extension (_data_->_tmp23_, E_SOURCE_EXTENSION_MAIL_SUBMISSION);
					_data_->submission_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp24_, e_source_mail_submission_get_type (), ESourceMailSubmission);
					_data_->_tmp25_ = _data_->submission_extension;
					_data_->_tmp26_ = e_source_mail_submission_get_transport_uid (_data_->_tmp25_);
					_data_->_tmp27_ = _data_->_tmp26_;
					if (g_strcmp0 (_data_->_tmp27_, "") != 0) {
						_data_->_tmp28_ = _data_->self->priv->registry;
						_data_->_tmp29_ = _data_->submission_extension;
						_data_->_tmp30_ = e_source_mail_submission_get_transport_uid (_data_->_tmp29_);
						_data_->_tmp31_ = _data_->_tmp30_;
						_data_->_tmp32_ = e_source_registry_ref_source (_data_->_tmp28_, _data_->_tmp31_);
						_g_object_unref0 (_data_->transport_source);
						_data_->transport_source = _data_->_tmp32_;
					}
				}
			}
		}
	}
	_data_->_tmp33_ = _data_->account_source;
	if (_data_->_tmp33_ == NULL) {
		_data_->_tmp35_ = g_strdup ("");
		_data_->_tmp36_ = NULL;
		_data_->_tmp36_ = e_source_new (NULL, NULL, &_data_->_inner_error0_);
		e_source_set_parent (_data_->_tmp36_, _data_->_tmp35_);
		_g_free0 (_data_->_tmp35_);
		_data_->_tmp34_ = _data_->_tmp36_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_object_unref0 (_data_->transport_source);
			_g_object_unref0 (_data_->identity_source);
			_g_object_unref0 (_data_->account_source);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp37_ = _data_->_tmp34_;
		_data_->_tmp34_ = NULL;
		_g_object_unref0 (_data_->account_source);
		_data_->account_source = _data_->_tmp37_;
		_g_object_unref0 (_data_->_tmp34_);
	}
	_data_->_tmp38_ = _data_->identity_source;
	if (_data_->_tmp38_ == NULL) {
		_data_->_tmp40_ = _data_->account_source;
		_data_->_tmp41_ = e_source_get_uid (_data_->_tmp40_);
		_data_->_tmp42_ = _data_->_tmp41_;
		_data_->_tmp43_ = g_strdup (_data_->_tmp42_);
		_data_->_tmp44_ = NULL;
		_data_->_tmp44_ = e_source_new (NULL, NULL, &_data_->_inner_error0_);
		e_source_set_parent (_data_->_tmp44_, _data_->_tmp43_);
		_g_free0 (_data_->_tmp43_);
		_data_->_tmp39_ = _data_->_tmp44_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_object_unref0 (_data_->transport_source);
			_g_object_unref0 (_data_->identity_source);
			_g_object_unref0 (_data_->account_source);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp45_ = _data_->_tmp39_;
		_data_->_tmp39_ = NULL;
		_g_object_unref0 (_data_->identity_source);
		_data_->identity_source = _data_->_tmp45_;
		_g_object_unref0 (_data_->_tmp39_);
	}
	_data_->_tmp46_ = _data_->transport_source;
	if (_data_->_tmp46_ == NULL) {
		_data_->_tmp48_ = _data_->account_source;
		_data_->_tmp49_ = e_source_get_uid (_data_->_tmp48_);
		_data_->_tmp50_ = _data_->_tmp49_;
		_data_->_tmp51_ = g_strdup (_data_->_tmp50_);
		_data_->_tmp52_ = NULL;
		_data_->_tmp52_ = e_source_new (NULL, NULL, &_data_->_inner_error0_);
		e_source_set_parent (_data_->_tmp52_, _data_->_tmp51_);
		_g_free0 (_data_->_tmp51_);
		_data_->_tmp47_ = _data_->_tmp52_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_object_unref0 (_data_->transport_source);
			_g_object_unref0 (_data_->identity_source);
			_g_object_unref0 (_data_->account_source);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp53_ = _data_->_tmp47_;
		_data_->_tmp47_ = NULL;
		_g_object_unref0 (_data_->transport_source);
		_data_->transport_source = _data_->_tmp53_;
		_g_object_unref0 (_data_->_tmp47_);
	}
	_data_->_tmp54_ = _data_->account_source;
	_data_->_tmp55_ = _data_->identity_source;
	_data_->_tmp56_ = _data_->transport_source;
	_data_->_tmp57_ = _data_->self->priv->login_page;
	_data_->_tmp58_ = online_accounts_imap_login_page_get_display_name (_data_->_tmp57_);
	_data_->_tmp59_ = _data_->_tmp58_;
	e_source_set_display_name (_data_->_tmp56_, _data_->_tmp59_);
	e_source_set_display_name (_data_->_tmp55_, _data_->_tmp59_);
	e_source_set_display_name (_data_->_tmp54_, _data_->_tmp59_);
	_data_->_tmp60_ = _data_->account_source;
	_data_->_tmp61_ = e_source_get_extension (_data_->_tmp60_, E_SOURCE_EXTENSION_MAIL_ACCOUNT);
	_data_->_vala1_account_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp61_, e_source_mail_account_get_type (), ESourceMailAccount);
	_data_->_tmp62_ = _data_->_vala1_account_extension;
	_data_->_tmp63_ = _data_->identity_source;
	_data_->_tmp64_ = e_source_get_uid (_data_->_tmp63_);
	_data_->_tmp65_ = _data_->_tmp64_;
	e_source_mail_account_set_identity_uid (_data_->_tmp62_, _data_->_tmp65_);
	_data_->_tmp66_ = _data_->_vala1_account_extension;
	e_source_mail_account_set_needs_initial_setup (_data_->_tmp66_, TRUE);
	_data_->_tmp67_ = _data_->_vala1_account_extension;
	e_source_backend_set_backend_name ((ESourceBackend*) _data_->_tmp67_, "imapx");
	_data_->_tmp68_ = _data_->account_source;
	_data_->_tmp69_ = e_source_get_extension (_data_->_tmp68_, E_SOURCE_EXTENSION_SECURITY);
	_data_->account_security_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp69_, e_source_security_get_type (), ESourceSecurity);
	_data_->_tmp70_ = _data_->account_security_extension;
	_data_->_tmp71_ = _data_->self->priv->imap_encryption_combobox;
	_data_->_tmp72_ = gtk_combo_box_get_active_id ((GtkComboBox*) _data_->_tmp71_);
	_data_->_tmp73_ = _data_->_tmp72_;
	e_source_security_set_method (_data_->_tmp70_, _data_->_tmp73_);
	_data_->_tmp74_ = _data_->account_source;
	_data_->_tmp75_ = e_source_get_extension (_data_->_tmp74_, E_SOURCE_EXTENSION_AUTHENTICATION);
	_data_->account_auth_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp75_, e_source_authentication_get_type (), ESourceAuthentication);
	_data_->_tmp76_ = _data_->account_auth_extension;
	_data_->_tmp77_ = _data_->self->priv->imap_server_entry;
	_data_->_tmp78_ = gtk_entry_get_text ((GtkEntry*) _data_->_tmp77_);
	_data_->_tmp79_ = _data_->_tmp78_;
	e_source_authentication_set_host (_data_->_tmp76_, _data_->_tmp79_);
	_data_->_tmp80_ = _data_->account_auth_extension;
	_data_->_tmp81_ = _data_->self->priv->imap_port_spin;
	_data_->_tmp82_ = gtk_spin_button_get_value (_data_->_tmp81_);
	_data_->_tmp83_ = _data_->_tmp82_;
	e_source_authentication_set_port (_data_->_tmp80_, (guint) _data_->_tmp83_);
	_data_->_tmp84_ = _data_->account_auth_extension;
	_data_->_tmp85_ = _data_->self->priv->imap_username_entry;
	_data_->_tmp86_ = gtk_entry_get_text ((GtkEntry*) _data_->_tmp85_);
	_data_->_tmp87_ = _data_->_tmp86_;
	e_source_authentication_set_user (_data_->_tmp84_, _data_->_tmp87_);
	_data_->_tmp88_ = _data_->account_source;
	_data_->_tmp89_ = e_source_get_extension (_data_->_tmp88_, E_SOURCE_EXTENSION_REFRESH);
	_data_->refresh_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp89_, e_source_refresh_get_type (), ESourceRefresh);
	_data_->_tmp90_ = _data_->refresh_extension;
	e_source_refresh_set_enabled (_data_->_tmp90_, TRUE);
	_data_->_tmp91_ = _data_->refresh_extension;
	e_source_refresh_set_interval_minutes (_data_->_tmp91_, (guint) 10);
	_data_->_tmp92_ = _data_->identity_source;
	_data_->_tmp93_ = e_source_get_extension (_data_->_tmp92_, E_SOURCE_EXTENSION_MAIL_SUBMISSION);
	_data_->_vala1_submission_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp93_, e_source_mail_submission_get_type (), ESourceMailSubmission);
	_data_->_tmp94_ = _data_->_vala1_submission_extension;
	_data_->_tmp95_ = _data_->transport_source;
	_data_->_tmp96_ = e_source_get_uid (_data_->_tmp95_);
	_data_->_tmp97_ = _data_->_tmp96_;
	e_source_mail_submission_set_transport_uid (_data_->_tmp94_, _data_->_tmp97_);
	_data_->_tmp98_ = _data_->identity_source;
	_data_->_tmp99_ = e_source_get_extension (_data_->_tmp98_, E_SOURCE_EXTENSION_MAIL_IDENTITY);
	_data_->identity_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp99_, e_source_mail_identity_get_type (), ESourceMailIdentity);
	_data_->_tmp100_ = _data_->identity_extension;
	_data_->_tmp101_ = _data_->self->priv->login_page;
	_data_->_tmp102_ = online_accounts_imap_login_page_get_email (_data_->_tmp101_);
	_data_->_tmp103_ = _data_->_tmp102_;
	e_source_mail_identity_set_address (_data_->_tmp100_, _data_->_tmp103_);
	_data_->_tmp104_ = _data_->identity_extension;
	_data_->_tmp105_ = _data_->self->priv->login_page;
	_data_->_tmp106_ = online_accounts_imap_login_page_get_real_name (_data_->_tmp105_);
	_data_->_tmp107_ = _data_->_tmp106_;
	e_source_mail_identity_set_name (_data_->_tmp104_, _data_->_tmp107_);
	_data_->_tmp108_ = _data_->identity_source;
	_data_->_tmp109_ = e_source_get_extension (_data_->_tmp108_, E_SOURCE_EXTENSION_MAIL_COMPOSITION);
	_data_->composition_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp109_, e_source_mail_composition_get_type (), ESourceMailComposition);
	_data_->_tmp110_ = _data_->transport_source;
	_data_->_tmp111_ = e_source_get_extension (_data_->_tmp110_, E_SOURCE_EXTENSION_MAIL_TRANSPORT);
	_data_->transport_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp111_, e_source_mail_transport_get_type (), ESourceMailTransport);
	_data_->_tmp112_ = _data_->transport_extension;
	e_source_backend_set_backend_name ((ESourceBackend*) _data_->_tmp112_, "smtp");
	_data_->_tmp113_ = _data_->transport_source;
	_data_->_tmp114_ = e_source_get_extension (_data_->_tmp113_, E_SOURCE_EXTENSION_SECURITY);
	_data_->transport_security_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp114_, e_source_security_get_type (), ESourceSecurity);
	_data_->_tmp115_ = _data_->transport_security_extension;
	_data_->_tmp116_ = _data_->self->priv->smtp_encryption_combobox;
	_data_->_tmp117_ = gtk_combo_box_get_active_id ((GtkComboBox*) _data_->_tmp116_);
	_data_->_tmp118_ = _data_->_tmp117_;
	e_source_security_set_method (_data_->_tmp115_, _data_->_tmp118_);
	_data_->_tmp119_ = _data_->transport_source;
	_data_->_tmp120_ = e_source_get_extension (_data_->_tmp119_, E_SOURCE_EXTENSION_AUTHENTICATION);
	_data_->transport_auth_extension = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp120_, e_source_authentication_get_type (), ESourceAuthentication);
	_data_->_tmp121_ = _data_->transport_auth_extension;
	_data_->_tmp122_ = _data_->self->priv->smtp_server_entry;
	_data_->_tmp123_ = gtk_entry_get_text ((GtkEntry*) _data_->_tmp122_);
	_data_->_tmp124_ = _data_->_tmp123_;
	e_source_authentication_set_host (_data_->_tmp121_, _data_->_tmp124_);
	_data_->_tmp125_ = _data_->transport_auth_extension;
	_data_->_tmp126_ = _data_->self->priv->smtp_port_spin;
	_data_->_tmp127_ = gtk_spin_button_get_value (_data_->_tmp126_);
	_data_->_tmp128_ = _data_->_tmp127_;
	e_source_authentication_set_port (_data_->_tmp125_, (guint) _data_->_tmp128_);
	_data_->_tmp129_ = _data_->transport_auth_extension;
	_data_->_tmp130_ = _data_->self->priv->smtp_username_entry;
	_data_->_tmp131_ = gtk_entry_get_text (_data_->_tmp130_);
	_data_->_tmp132_ = _data_->_tmp131_;
	e_source_authentication_set_user (_data_->_tmp129_, _data_->_tmp132_);
	_data_->_tmp133_ = online_accounts_camel_session_get_default ();
	_data_->session = _data_->_tmp133_;
	g_debug ("ImapDialog.vala:550: Add imap service for mail account extension");
	_data_->_tmp134_ = _data_->session;
	_data_->_tmp135_ = _data_->account_source;
	_data_->_tmp136_ = e_source_get_uid (_data_->_tmp135_);
	_data_->_tmp137_ = _data_->_tmp136_;
	_data_->_tmp138_ = _data_->_vala1_account_extension;
	_data_->_tmp139_ = e_source_backend_get_backend_name ((ESourceBackend*) _data_->_tmp138_);
	_data_->_tmp140_ = _data_->_tmp139_;
	_data_->_tmp141_ = camel_session_add_service ((CamelSession*) _data_->_tmp134_, _data_->_tmp137_, _data_->_tmp140_, CAMEL_PROVIDER_STORE, &_data_->_inner_error0_);
	_data_->imap_service = _data_->_tmp141_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp142_ = _data_->imap_service;
	_data_->_tmp143_ = _data_->self->priv->login_page;
	_data_->_tmp144_ = online_accounts_imap_login_page_get_password (_data_->_tmp143_);
	_data_->_tmp145_ = _data_->_tmp144_;
	camel_service_set_password (_data_->_tmp142_, _data_->_tmp145_);
	_data_->_tmp146_ = _data_->account_source;
	_data_->_tmp147_ = _data_->imap_service;
	e_source_camel_configure_service (_data_->_tmp146_, _data_->_tmp147_);
	_data_->_tmp148_ = _data_->imap_service;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp148_, camel_network_service_get_type ())) {
		g_debug ("ImapDialog.vala:556: Test if we can reach the imap service…");
		_data_->_tmp149_ = _data_->imap_service;
		_data_->_tmp150_ = _data_->self->priv->cancellable;
		_data_->_state_ = 2;
		camel_network_service_can_reach (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp149_, camel_network_service_get_type (), CamelNetworkService), _data_->_tmp150_, online_accounts_imap_dialog_save_configuration_ready, _data_);
		return FALSE;
		_state_2:
		camel_network_service_can_reach_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp149_, camel_network_service_get_type (), CamelNetworkService), _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_object_unref0 (_data_->imap_service);
			_g_object_unref0 (_data_->transport_source);
			_g_object_unref0 (_data_->identity_source);
			_g_object_unref0 (_data_->account_source);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp151_ = _data_->imap_service;
	_data_->_tmp152_ = _data_->self->priv->cancellable;
	_data_->_tmp153_ = camel_service_query_auth_types_sync (_data_->_tmp151_, _data_->_tmp152_, &_data_->_inner_error0_);
	_data_->imap_auth_types = _data_->_tmp153_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_object_unref0 (_data_->imap_service);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->imap_auth_error = NULL;
	_data_->_tmp154_ = _data_->imap_auth_types;
	{
		_data_->imap_auth_type_collection = _data_->_tmp154_;
		for (_data_->imap_auth_type_it = _data_->imap_auth_type_collection; _data_->imap_auth_type_it != NULL; _data_->imap_auth_type_it = _data_->imap_auth_type_it->next) {
			_data_->imap_auth_type = (CamelServiceAuthType*) _data_->imap_auth_type_it->data;
			{
				_data_->_tmp155_ = _data_->imap_auth_type;
				_data_->_tmp156_ = _data_->_tmp155_->name;
				g_debug ("ImapDialog.vala:563: Testing %s authentication for imap service…", _data_->_tmp156_);
				_data_->_tmp157_ = _data_->account_auth_extension;
				_data_->_tmp158_ = _data_->imap_auth_type;
				_data_->_tmp159_ = _data_->_tmp158_->authproto;
				e_source_authentication_set_method (_data_->_tmp157_, _data_->_tmp159_);
				_data_->_tmp160_ = _data_->account_source;
				_data_->_tmp161_ = _data_->imap_service;
				e_source_camel_configure_service (_data_->_tmp160_, _data_->_tmp161_);
				_data_->_tmp162_ = g_cancellable_new ();
				_data_->imap_auth_cancellable = _data_->_tmp162_;
				_data_->_tmp163_ = _data_->imap_auth_cancellable;
				online_accounts_imap_dialog_set_cancel_timeout (_data_->self, _data_->_tmp163_);
				{
					_data_->_tmp164_ = _data_->imap_service;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp164_, camel_offline_store_get_type ())) {
						g_debug ("ImapDialog.vala:573: Setting the imap service online…");
						_data_->_tmp165_ = _data_->imap_service;
						_data_->_tmp166_ = _data_->imap_auth_cancellable;
						_data_->_state_ = 3;
						camel_offline_store_set_online (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp165_, camel_offline_store_get_type (), CamelOfflineStore), TRUE, G_PRIORITY_DEFAULT, _data_->_tmp166_, online_accounts_imap_dialog_save_configuration_ready, _data_);
						return FALSE;
						_state_3:
						camel_offline_store_set_online_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp165_, camel_offline_store_get_type (), CamelOfflineStore), _data_->_res_, &_data_->_inner_error0_);
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
							goto __catch0_g_error;
						}
					} else {
						g_debug ("ImapDialog.vala:576: Connecting to the imap service…");
						_data_->_tmp167_ = _data_->imap_service;
						_data_->_tmp168_ = _data_->imap_auth_cancellable;
						_data_->_state_ = 4;
						camel_service_connect (_data_->_tmp167_, G_PRIORITY_DEFAULT, _data_->_tmp168_, online_accounts_imap_dialog_save_configuration_ready, _data_);
						return FALSE;
						_state_4:
						camel_service_connect_finish (_data_->_tmp167_, _data_->_res_, &_data_->_inner_error0_);
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
							goto __catch0_g_error;
						}
					}
					_data_->_tmp169_ = _data_->imap_auth_type;
					_data_->_tmp170_ = _data_->_tmp169_->name;
					g_debug ("ImapDialog.vala:580: Successfully connected to the imap service using " \
"%s authentication.", _data_->_tmp170_);
					_g_error_free0 (_data_->imap_auth_error);
					_data_->imap_auth_error = NULL;
					_g_object_unref0 (_data_->imap_auth_cancellable);
					break;
				}
				goto __finally0;
				__catch0_g_error:
				{
					_data_->e = _data_->_inner_error0_;
					_data_->_inner_error0_ = NULL;
					_data_->_tmp171_ = _data_->imap_auth_type;
					_data_->_tmp172_ = _data_->_tmp171_->name;
					_data_->_tmp173_ = _data_->e;
					_data_->_tmp174_ = _data_->_tmp173_->message;
					g_debug ("ImapDialog.vala:585: Error using %s authentication for imap service: %" \
"s", _data_->_tmp172_, _data_->_tmp174_);
					_data_->_tmp175_ = _data_->e;
					if (g_error_matches (_data_->_tmp175_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
						_data_->_tmp176_ = g_error_new (camel_service_error_quark (), CAMEL_SERVICE_ERROR_CANT_AUTHENTICATE, "%s", _ ("Could not log in. Please verify your credentials."));
						_g_error_free0 (_data_->imap_auth_error);
						_data_->imap_auth_error = _data_->_tmp176_;
					} else {
						_data_->_tmp177_ = _data_->e;
						_data_->_tmp178_ = _g_error_copy0 (_data_->_tmp177_);
						_g_error_free0 (_data_->imap_auth_error);
						_data_->imap_auth_error = _data_->_tmp178_;
					}
					_g_error_free0 (_data_->e);
				}
				__finally0:
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
					_g_object_unref0 (_data_->imap_auth_cancellable);
					_g_error_free0 (_data_->imap_auth_error);
					(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
					_g_object_unref0 (_data_->imap_service);
					_g_object_unref0 (_data_->transport_source);
					_g_object_unref0 (_data_->identity_source);
					_g_object_unref0 (_data_->account_source);
					g_object_unref (_data_->_async_result);
					return FALSE;
				}
				online_accounts_imap_dialog_unset_cancel_timeout (_data_->self);
				_g_object_unref0 (_data_->imap_auth_cancellable);
			}
		}
	}
	_data_->_tmp179_ = _data_->imap_auth_error;
	if (_data_->_tmp179_ != NULL) {
		_data_->_tmp180_ = _data_->imap_auth_error;
		_data_->_tmp181_ = _data_->_tmp180_->message;
		_data_->_tmp182_ = g_strdup_printf (_ ("IMAP verification failed: %s"), _data_->_tmp181_);
		_data_->_tmp183_ = _data_->_tmp182_;
		_data_->_tmp184_ = g_error_new (camel_service_error_quark (), CAMEL_SERVICE_ERROR_CANT_AUTHENTICATE, "%s", _data_->_tmp183_);
		_data_->_tmp185_ = _data_->_tmp184_;
		_g_free0 (_data_->_tmp183_);
		_data_->_inner_error0_ = _data_->_tmp185_;
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_error_free0 (_data_->imap_auth_error);
		(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
		_g_object_unref0 (_data_->imap_service);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp186_ = _data_->imap_service;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp186_, camel_store_get_type ())) {
		_data_->_tmp187_ = _data_->imap_service;
		_data_->_tmp188_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp187_, camel_store_get_type (), CamelStore));
		_data_->imap_store = _data_->_tmp188_;
		{
			_data_->_tmp189_ = _data_->imap_store;
			_data_->_tmp190_ = _data_->self->priv->cancellable;
			_data_->_tmp191_ = NULL;
			camel_store_initial_setup_sync (_data_->_tmp189_, &_data_->_tmp191_, _data_->_tmp190_, &_data_->_inner_error0_);
			_g_hash_table_unref0 (_data_->save_setup);
			_data_->save_setup = _data_->_tmp191_;
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				_g_hash_table_unref0 (_data_->save_setup);
				goto __catch1_g_error;
			}
			_data_->_tmp192_ = _data_->save_setup;
			if (_data_->_tmp192_ == NULL) {
				g_warning ("ImapDialog.vala:617: Initial setup is NULL. Well known folders will pr" \
"obably not work correctly.");
			} else {
				_data_->_tmp193_ = _data_->account_source;
				_data_->_tmp194_ = e_source_get_uid (_data_->_tmp193_);
				_data_->_tmp195_ = _data_->_tmp194_;
				_data_->_tmp196_ = camel_url_encode (_data_->_tmp195_, ":;@/");
				_data_->encoded_account_uri = _data_->_tmp196_;
				_data_->_tmp197_ = _data_->save_setup;
				_data_->_tmp198_ = g_hash_table_get_keys (_data_->_tmp197_);
				{
					_data_->key_collection = _data_->_tmp198_;
					for (_data_->key_it = _data_->key_collection; _data_->key_it != NULL; _data_->key_it = _data_->key_it->next) {
						_data_->key = (const gchar*) _data_->key_it->data;
						{
							_data_->_tmp199_ = _data_->key;
							_data_->_tmp201_ = _data_->_tmp200_ = g_strsplit (_data_->_tmp199_, ":", 0);
							_data_->keys = _data_->_tmp201_;
							_data_->keys_length1 = _vala_array_length (_data_->_tmp200_);
							_data_->_keys_size_ = _data_->keys_length1;
							_data_->_tmp203_ = _data_->keys;
							_data_->_tmp203__length1 = _data_->keys_length1;
							if (_data_->_tmp203__length1 < 3) {
								_data_->_tmp202_ = TRUE;
							} else {
								_data_->_tmp204_ = _data_->keys;
								_data_->_tmp204__length1 = _data_->keys_length1;
								_data_->_tmp202_ = _data_->_tmp204__length1 > 4;
							}
							if (_data_->_tmp202_) {
								_data_->_tmp205_ = _data_->keys;
								_data_->_tmp205__length1 = _data_->keys_length1;
								_data_->_tmp206_ = _data_->key;
								g_warning ("ImapDialog.vala:640: Incorrect store setup key. 3 or 4 parts expected," \
" but %d given in “%s”", _data_->_tmp205__length1, _data_->_tmp206_);
								_data_->keys = (_vala_array_free (_data_->keys, _data_->keys_length1, (GDestroyNotify) g_free), NULL);
								continue;
							} else {
								static GQuark _tmp218_label0 = 0;
								static GQuark _tmp218_label1 = 0;
								_data_->_tmp207_ = _data_->keys;
								_data_->_tmp207__length1 = _data_->keys_length1;
								_data_->_tmp208_ = _data_->_tmp207_[0];
								_data_->_tmp209_ = g_strdup (_data_->_tmp208_);
								_data_->save_setup_source_type = _data_->_tmp209_;
								_data_->_tmp210_ = _data_->keys;
								_data_->_tmp210__length1 = _data_->keys_length1;
								_data_->_tmp211_ = _data_->_tmp210_[1];
								_data_->_tmp212_ = g_strdup (_data_->_tmp211_);
								_data_->save_setup_extension_name = _data_->_tmp212_;
								_data_->_tmp213_ = _data_->keys;
								_data_->_tmp213__length1 = _data_->keys_length1;
								_data_->_tmp214_ = _data_->_tmp213_[2];
								_data_->_tmp215_ = g_strdup (_data_->_tmp214_);
								_data_->save_setup_property_name = _data_->_tmp215_;
								_data_->_tmp216_ = _data_->save_setup_source_type;
								_data_->_tmp219_ = 0U;
								_data_->_tmp217_ = _data_->_tmp216_;
								_data_->_tmp219_ = (NULL == _data_->_tmp217_) ? 0 : g_quark_from_string (_data_->_tmp217_);
								if (_data_->_tmp219_ == ((0 != _tmp218_label0) ? _tmp218_label0 : (_tmp218_label0 = g_quark_from_static_string ("Account")))) {
									switch (0) {
										default:
										{
											_data_->_tmp221_ = _data_->save_setup_extension_name;
											if (g_strcmp0 (_data_->_tmp221_, E_SOURCE_EXTENSION_MAIL_ACCOUNT) == 0) {
												_data_->_tmp222_ = _data_->save_setup_property_name;
												_data_->_tmp220_ = g_strcmp0 (_data_->_tmp222_, "archive-folder") == 0;
											} else {
												_data_->_tmp220_ = FALSE;
											}
											if (_data_->_tmp220_) {
												_data_->_tmp223_ = _data_->_vala1_account_extension;
												_data_->_tmp224_ = _data_->encoded_account_uri;
												_data_->_tmp225_ = _data_->save_setup;
												_data_->_tmp226_ = _data_->key;
												_data_->_tmp227_ = g_hash_table_lookup (_data_->_tmp225_, _data_->_tmp226_);
												_data_->_tmp228_ = camel_url_encode ((const gchar*) _data_->_tmp227_, ":;@?#");
												_data_->_tmp229_ = _data_->_tmp228_;
												_data_->_tmp230_ = g_strdup_printf ("folder://%s/%s", _data_->_tmp224_, _data_->_tmp229_);
												_data_->_tmp231_ = _data_->_tmp230_;
												e_source_mail_account_set_archive_folder (_data_->_tmp223_, _data_->_tmp231_);
												_g_free0 (_data_->_tmp231_);
												_g_free0 (_data_->_tmp229_);
											}
											break;
										}
									}
								} else if (_data_->_tmp219_ == ((0 != _tmp218_label1) ? _tmp218_label1 : (_tmp218_label1 = g_quark_from_static_string ("Submission")))) {
									switch (0) {
										default:
										{
											_data_->_tmp233_ = _data_->save_setup_extension_name;
											if (g_strcmp0 (_data_->_tmp233_, E_SOURCE_EXTENSION_MAIL_COMPOSITION) == 0) {
												_data_->_tmp234_ = _data_->save_setup_property_name;
												_data_->_tmp232_ = g_strcmp0 (_data_->_tmp234_, "drafts-folder") == 0;
											} else {
												_data_->_tmp232_ = FALSE;
											}
											if (_data_->_tmp232_) {
												_data_->_tmp235_ = _data_->composition_extension;
												_data_->_tmp236_ = _data_->encoded_account_uri;
												_data_->_tmp237_ = _data_->save_setup;
												_data_->_tmp238_ = _data_->key;
												_data_->_tmp239_ = g_hash_table_lookup (_data_->_tmp237_, _data_->_tmp238_);
												_data_->_tmp240_ = camel_url_encode ((const gchar*) _data_->_tmp239_, ":;@?#");
												_data_->_tmp241_ = _data_->_tmp240_;
												_data_->_tmp242_ = g_strdup_printf ("folder://%s/%s", _data_->_tmp236_, _data_->_tmp241_);
												_data_->_tmp243_ = _data_->_tmp242_;
												e_source_mail_composition_set_drafts_folder (_data_->_tmp235_, _data_->_tmp243_);
												_g_free0 (_data_->_tmp243_);
												_g_free0 (_data_->_tmp241_);
											} else {
												_data_->_tmp245_ = _data_->save_setup_extension_name;
												if (g_strcmp0 (_data_->_tmp245_, E_SOURCE_EXTENSION_MAIL_SUBMISSION) == 0) {
													_data_->_tmp246_ = _data_->save_setup_property_name;
													_data_->_tmp244_ = g_strcmp0 (_data_->_tmp246_, "sent-folder") == 0;
												} else {
													_data_->_tmp244_ = FALSE;
												}
												if (_data_->_tmp244_) {
													_data_->_tmp247_ = _data_->_vala1_submission_extension;
													_data_->_tmp248_ = _data_->encoded_account_uri;
													_data_->_tmp249_ = _data_->save_setup;
													_data_->_tmp250_ = _data_->key;
													_data_->_tmp251_ = g_hash_table_lookup (_data_->_tmp249_, _data_->_tmp250_);
													_data_->_tmp252_ = camel_url_encode ((const gchar*) _data_->_tmp251_, ":;@?#");
													_data_->_tmp253_ = _data_->_tmp252_;
													_data_->_tmp254_ = g_strdup_printf ("folder://%s/%s", _data_->_tmp248_, _data_->_tmp253_);
													_data_->_tmp255_ = _data_->_tmp254_;
													e_source_mail_submission_set_sent_folder (_data_->_tmp247_, _data_->_tmp255_);
													_g_free0 (_data_->_tmp255_);
													_g_free0 (_data_->_tmp253_);
												}
											}
											break;
										}
									}
								} else {
									switch (0) {
										default:
										{
											_data_->_tmp256_ = _data_->key;
											g_debug ("ImapDialog.vala:674: Initial setup key is not stored: “%s”", _data_->_tmp256_);
											break;
										}
									}
								}
								_g_free0 (_data_->save_setup_property_name);
								_g_free0 (_data_->save_setup_extension_name);
								_g_free0 (_data_->save_setup_source_type);
							}
							_data_->keys = (_vala_array_free (_data_->keys, _data_->keys_length1, (GDestroyNotify) g_free), NULL);
						}
					}
					(_data_->key_collection == NULL) ? NULL : (_data_->key_collection = (g_list_free (_data_->key_collection), NULL));
				}
				_data_->_tmp257_ = _data_->_vala1_account_extension;
				e_source_mail_account_set_needs_initial_setup (_data_->_tmp257_, FALSE);
				_g_free0 (_data_->encoded_account_uri);
			}
			_g_hash_table_unref0 (_data_->save_setup);
		}
		goto __finally1;
		__catch1_g_error:
		{
			_data_->_vala1_e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp258_ = _data_->_vala1_e;
			_data_->_tmp259_ = _data_->_tmp258_->message;
			g_warning ("ImapDialog.vala:684: Incomplete setup. It is possible to use this e-ma" \
"il account, but well known folders most likely will not work as expect" \
"ed: %s", _data_->_tmp259_);
			_g_error_free0 (_data_->_vala1_e);
		}
		__finally1:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_object_unref0 (_data_->imap_store);
			_g_error_free0 (_data_->imap_auth_error);
			(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
			_g_object_unref0 (_data_->imap_service);
			_g_object_unref0 (_data_->transport_source);
			_g_object_unref0 (_data_->identity_source);
			_g_object_unref0 (_data_->account_source);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_g_object_unref0 (_data_->imap_store);
	}
	_data_->_tmp260_ = _data_->self->priv->cancellable;
	if (g_cancellable_is_cancelled (_data_->_tmp260_)) {
		_g_error_free0 (_data_->imap_auth_error);
		(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
		_g_object_unref0 (_data_->imap_service);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_debug ("ImapDialog.vala:692: Add smtp service");
	_data_->_tmp261_ = _data_->session;
	_data_->_tmp262_ = _data_->transport_source;
	_data_->_tmp263_ = e_source_get_uid (_data_->_tmp262_);
	_data_->_tmp264_ = _data_->_tmp263_;
	_data_->_tmp265_ = _data_->transport_extension;
	_data_->_tmp266_ = e_source_backend_get_backend_name ((ESourceBackend*) _data_->_tmp265_);
	_data_->_tmp267_ = _data_->_tmp266_;
	_data_->_tmp268_ = camel_session_add_service ((CamelSession*) _data_->_tmp261_, _data_->_tmp264_, _data_->_tmp267_, CAMEL_PROVIDER_TRANSPORT, &_data_->_inner_error0_);
	_data_->transport_service = _data_->_tmp268_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_error_free0 (_data_->imap_auth_error);
		(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
		_g_object_unref0 (_data_->imap_service);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp269_ = _data_->transport_source;
	_data_->_tmp270_ = _data_->transport_service;
	e_source_camel_configure_service (_data_->_tmp269_, _data_->_tmp270_);
	_data_->_tmp271_ = _data_->self->priv->smtp_no_credentials;
	_data_->_tmp272_ = gtk_toggle_button_get_active ((GtkToggleButton*) _data_->_tmp271_);
	_data_->_tmp273_ = _data_->_tmp272_;
	if (!_data_->_tmp273_) {
		_data_->_tmp274_ = _data_->self->priv->use_imap_credentials;
		_data_->_tmp275_ = gtk_toggle_button_get_active ((GtkToggleButton*) _data_->_tmp274_);
		_data_->_tmp276_ = _data_->_tmp275_;
		if (_data_->_tmp276_) {
			_data_->_tmp277_ = _data_->transport_service;
			_data_->_tmp278_ = _data_->self->priv->login_page;
			_data_->_tmp279_ = online_accounts_imap_login_page_get_password (_data_->_tmp278_);
			_data_->_tmp280_ = _data_->_tmp279_;
			camel_service_set_password (_data_->_tmp277_, _data_->_tmp280_);
		} else {
			_data_->_tmp281_ = _data_->transport_service;
			_data_->_tmp282_ = _data_->self->priv->smtp_password_entry;
			_data_->_tmp283_ = gtk_entry_get_text (_data_->_tmp282_);
			_data_->_tmp284_ = _data_->_tmp283_;
			camel_service_set_password (_data_->_tmp281_, _data_->_tmp284_);
		}
	}
	_data_->_tmp285_ = _data_->transport_service;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp285_, camel_network_service_get_type ())) {
		g_debug ("ImapDialog.vala:705: Test if the smtp service can be reached…");
		_data_->_tmp286_ = _data_->transport_service;
		_data_->_tmp287_ = _data_->self->priv->cancellable;
		_data_->_state_ = 5;
		camel_network_service_can_reach (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp286_, camel_network_service_get_type (), CamelNetworkService), _data_->_tmp287_, online_accounts_imap_dialog_save_configuration_ready, _data_);
		return FALSE;
		_state_5:
		camel_network_service_can_reach_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp286_, camel_network_service_get_type (), CamelNetworkService), _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_object_unref0 (_data_->transport_service);
			_g_error_free0 (_data_->imap_auth_error);
			(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
			_g_object_unref0 (_data_->imap_service);
			_g_object_unref0 (_data_->transport_source);
			_g_object_unref0 (_data_->identity_source);
			_g_object_unref0 (_data_->account_source);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp288_ = _data_->transport_service;
	_data_->_tmp289_ = _data_->self->priv->cancellable;
	_data_->_tmp290_ = camel_service_query_auth_types_sync (_data_->_tmp288_, _data_->_tmp289_, &_data_->_inner_error0_);
	_data_->smtp_auth_types = _data_->_tmp290_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_object_unref0 (_data_->transport_service);
		_g_error_free0 (_data_->imap_auth_error);
		(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
		_g_object_unref0 (_data_->imap_service);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->smtp_auth_error = NULL;
	_data_->_tmp291_ = _data_->smtp_auth_types;
	{
		_data_->smtp_auth_type_collection = _data_->_tmp291_;
		for (_data_->smtp_auth_type_it = _data_->smtp_auth_type_collection; _data_->smtp_auth_type_it != NULL; _data_->smtp_auth_type_it = _data_->smtp_auth_type_it->next) {
			_data_->smtp_auth_type = (CamelServiceAuthType*) _data_->smtp_auth_type_it->data;
			{
				_data_->_tmp292_ = _data_->smtp_auth_type;
				_data_->_tmp293_ = _data_->_tmp292_->name;
				g_debug ("ImapDialog.vala:712: Testing %s authentication for smtp service…", _data_->_tmp293_);
				_data_->_tmp294_ = _data_->transport_auth_extension;
				_data_->_tmp295_ = _data_->smtp_auth_type;
				_data_->_tmp296_ = _data_->_tmp295_->authproto;
				e_source_authentication_set_method (_data_->_tmp294_, _data_->_tmp296_);
				_data_->_tmp297_ = _data_->transport_source;
				_data_->_tmp298_ = _data_->transport_service;
				e_source_camel_configure_service (_data_->_tmp297_, _data_->_tmp298_);
				_data_->_tmp299_ = g_cancellable_new ();
				_data_->smtp_auth_cancellable = _data_->_tmp299_;
				_data_->_tmp300_ = _data_->smtp_auth_cancellable;
				online_accounts_imap_dialog_set_cancel_timeout (_data_->self, _data_->_tmp300_);
				{
					g_debug ("ImapDialog.vala:721: Connecting to the smtp service…");
					_data_->_tmp301_ = _data_->transport_service;
					_data_->_tmp302_ = _data_->smtp_auth_cancellable;
					_data_->_state_ = 6;
					camel_service_connect (_data_->_tmp301_, G_PRIORITY_DEFAULT, _data_->_tmp302_, online_accounts_imap_dialog_save_configuration_ready, _data_);
					return FALSE;
					_state_6:
					camel_service_connect_finish (_data_->_tmp301_, _data_->_res_, &_data_->_inner_error0_);
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
						goto __catch2_g_error;
					}
					_data_->_tmp303_ = _data_->smtp_auth_type;
					_data_->_tmp304_ = _data_->_tmp303_->name;
					g_debug ("ImapDialog.vala:724: Successfully connected to the smtp service using " \
"%s authentication.", _data_->_tmp304_);
					_g_error_free0 (_data_->smtp_auth_error);
					_data_->smtp_auth_error = NULL;
					_g_object_unref0 (_data_->smtp_auth_cancellable);
					break;
				}
				goto __finally2;
				__catch2_g_error:
				{
					_data_->_vala2_e = _data_->_inner_error0_;
					_data_->_inner_error0_ = NULL;
					_data_->_tmp305_ = _data_->smtp_auth_type;
					_data_->_tmp306_ = _data_->_tmp305_->name;
					_data_->_tmp307_ = _data_->_vala2_e;
					_data_->_tmp308_ = _data_->_tmp307_->message;
					g_debug ("ImapDialog.vala:729: Error using %s authentication for smtp service: %" \
"s", _data_->_tmp306_, _data_->_tmp308_);
					_data_->_tmp309_ = _data_->_vala2_e;
					if (g_error_matches (_data_->_tmp309_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
						_data_->_tmp310_ = g_error_new (camel_service_error_quark (), CAMEL_SERVICE_ERROR_CANT_AUTHENTICATE, "Could not log in. Please verify your credentials.");
						_g_error_free0 (_data_->smtp_auth_error);
						_data_->smtp_auth_error = _data_->_tmp310_;
					} else {
						_data_->_tmp311_ = _data_->_vala2_e;
						_data_->_tmp312_ = _g_error_copy0 (_data_->_tmp311_);
						_g_error_free0 (_data_->smtp_auth_error);
						_data_->smtp_auth_error = _data_->_tmp312_;
					}
					_g_error_free0 (_data_->_vala2_e);
				}
				__finally2:
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
					_g_object_unref0 (_data_->smtp_auth_cancellable);
					_g_error_free0 (_data_->smtp_auth_error);
					(_data_->smtp_auth_types == NULL) ? NULL : (_data_->smtp_auth_types = (g_list_free (_data_->smtp_auth_types), NULL));
					_g_object_unref0 (_data_->transport_service);
					_g_error_free0 (_data_->imap_auth_error);
					(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
					_g_object_unref0 (_data_->imap_service);
					_g_object_unref0 (_data_->transport_source);
					_g_object_unref0 (_data_->identity_source);
					_g_object_unref0 (_data_->account_source);
					g_object_unref (_data_->_async_result);
					return FALSE;
				}
				online_accounts_imap_dialog_unset_cancel_timeout (_data_->self);
				_g_object_unref0 (_data_->smtp_auth_cancellable);
			}
		}
	}
	_data_->_tmp313_ = _data_->smtp_auth_error;
	if (_data_->_tmp313_ != NULL) {
		_data_->_tmp314_ = _data_->smtp_auth_error;
		_data_->_tmp315_ = _data_->_tmp314_->message;
		_data_->_tmp316_ = g_strdup_printf ("SMTP verification failed: %s", _data_->_tmp315_);
		_data_->_tmp317_ = _data_->_tmp316_;
		_data_->_tmp318_ = g_error_new (camel_service_error_quark (), CAMEL_SERVICE_ERROR_CANT_AUTHENTICATE, "%s", _data_->_tmp317_);
		_data_->_tmp319_ = _data_->_tmp318_;
		_g_free0 (_data_->_tmp317_);
		_data_->_inner_error0_ = _data_->_tmp319_;
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_error_free0 (_data_->smtp_auth_error);
		(_data_->smtp_auth_types == NULL) ? NULL : (_data_->smtp_auth_types = (g_list_free (_data_->smtp_auth_types), NULL));
		_g_object_unref0 (_data_->transport_service);
		_g_error_free0 (_data_->imap_auth_error);
		(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
		_g_object_unref0 (_data_->imap_service);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp320_ = _data_->self->priv->cancellable;
	if (g_cancellable_is_cancelled (_data_->_tmp320_)) {
		_g_error_free0 (_data_->smtp_auth_error);
		(_data_->smtp_auth_types == NULL) ? NULL : (_data_->smtp_auth_types = (g_list_free (_data_->smtp_auth_types), NULL));
		_g_object_unref0 (_data_->transport_service);
		_g_error_free0 (_data_->imap_auth_error);
		(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
		_g_object_unref0 (_data_->imap_service);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp321_ = _data_->account_source;
	_data_->_tmp322_ = _data_->self->priv->login_page;
	_data_->_tmp323_ = online_accounts_imap_login_page_get_password (_data_->_tmp322_);
	_data_->_tmp324_ = _data_->_tmp323_;
	_data_->_tmp325_ = _data_->self->priv->cancellable;
	_data_->_state_ = 7;
	e_source_store_password (_data_->_tmp321_, _data_->_tmp324_, TRUE, _data_->_tmp325_, online_accounts_imap_dialog_save_configuration_ready, _data_);
	return FALSE;
	_state_7:
	e_source_store_password_finish (_data_->_tmp321_, _data_->_res_, &_data_->_inner_error0_);
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_error_free0 (_data_->smtp_auth_error);
		(_data_->smtp_auth_types == NULL) ? NULL : (_data_->smtp_auth_types = (g_list_free (_data_->smtp_auth_types), NULL));
		_g_object_unref0 (_data_->transport_service);
		_g_error_free0 (_data_->imap_auth_error);
		(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
		_g_object_unref0 (_data_->imap_service);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp326_ = _data_->self->priv->use_imap_credentials;
	_data_->_tmp327_ = gtk_toggle_button_get_active ((GtkToggleButton*) _data_->_tmp326_);
	_data_->_tmp328_ = _data_->_tmp327_;
	if (_data_->_tmp328_) {
		_data_->_tmp329_ = _data_->transport_source;
		_data_->_tmp330_ = _data_->self->priv->login_page;
		_data_->_tmp331_ = online_accounts_imap_login_page_get_password (_data_->_tmp330_);
		_data_->_tmp332_ = _data_->_tmp331_;
		_data_->_tmp333_ = _data_->self->priv->cancellable;
		_data_->_state_ = 8;
		e_source_store_password (_data_->_tmp329_, _data_->_tmp332_, TRUE, _data_->_tmp333_, online_accounts_imap_dialog_save_configuration_ready, _data_);
		return FALSE;
		_state_8:
		e_source_store_password_finish (_data_->_tmp329_, _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_error_free0 (_data_->smtp_auth_error);
			(_data_->smtp_auth_types == NULL) ? NULL : (_data_->smtp_auth_types = (g_list_free (_data_->smtp_auth_types), NULL));
			_g_object_unref0 (_data_->transport_service);
			_g_error_free0 (_data_->imap_auth_error);
			(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
			_g_object_unref0 (_data_->imap_service);
			_g_object_unref0 (_data_->transport_source);
			_g_object_unref0 (_data_->identity_source);
			_g_object_unref0 (_data_->account_source);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	} else {
		_data_->_tmp334_ = _data_->transport_source;
		_data_->_tmp335_ = _data_->self->priv->smtp_password_entry;
		_data_->_tmp336_ = gtk_entry_get_text (_data_->_tmp335_);
		_data_->_tmp337_ = _data_->_tmp336_;
		_data_->_tmp338_ = _data_->self->priv->cancellable;
		_data_->_state_ = 9;
		e_source_store_password (_data_->_tmp334_, _data_->_tmp337_, TRUE, _data_->_tmp338_, online_accounts_imap_dialog_save_configuration_ready, _data_);
		return FALSE;
		_state_9:
		e_source_store_password_finish (_data_->_tmp334_, _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_error_free0 (_data_->smtp_auth_error);
			(_data_->smtp_auth_types == NULL) ? NULL : (_data_->smtp_auth_types = (g_list_free (_data_->smtp_auth_types), NULL));
			_g_object_unref0 (_data_->transport_service);
			_g_error_free0 (_data_->imap_auth_error);
			(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
			_g_object_unref0 (_data_->imap_service);
			_g_object_unref0 (_data_->transport_source);
			_g_object_unref0 (_data_->identity_source);
			_g_object_unref0 (_data_->account_source);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp339_ = _data_->self->priv->registry;
	_data_->_tmp340_ = _data_->account_source;
	_data_->_tmp341_ = _data_->self->priv->cancellable;
	_data_->_state_ = 10;
	e_source_registry_commit_source (_data_->_tmp339_, _data_->_tmp340_, _data_->_tmp341_, online_accounts_imap_dialog_save_configuration_ready, _data_);
	return FALSE;
	_state_10:
	e_source_registry_commit_source_finish (_data_->_tmp339_, _data_->_res_, &_data_->_inner_error0_);
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_error_free0 (_data_->smtp_auth_error);
		(_data_->smtp_auth_types == NULL) ? NULL : (_data_->smtp_auth_types = (g_list_free (_data_->smtp_auth_types), NULL));
		_g_object_unref0 (_data_->transport_service);
		_g_error_free0 (_data_->imap_auth_error);
		(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
		_g_object_unref0 (_data_->imap_service);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp342_ = _data_->self->priv->registry;
	_data_->_tmp343_ = _data_->identity_source;
	_data_->_tmp344_ = _data_->self->priv->cancellable;
	_data_->_state_ = 11;
	e_source_registry_commit_source (_data_->_tmp342_, _data_->_tmp343_, _data_->_tmp344_, online_accounts_imap_dialog_save_configuration_ready, _data_);
	return FALSE;
	_state_11:
	e_source_registry_commit_source_finish (_data_->_tmp342_, _data_->_res_, &_data_->_inner_error0_);
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_error_free0 (_data_->smtp_auth_error);
		(_data_->smtp_auth_types == NULL) ? NULL : (_data_->smtp_auth_types = (g_list_free (_data_->smtp_auth_types), NULL));
		_g_object_unref0 (_data_->transport_service);
		_g_error_free0 (_data_->imap_auth_error);
		(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
		_g_object_unref0 (_data_->imap_service);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp345_ = _data_->self->priv->registry;
	_data_->_tmp346_ = _data_->transport_source;
	_data_->_tmp347_ = _data_->self->priv->cancellable;
	_data_->_state_ = 12;
	e_source_registry_commit_source (_data_->_tmp345_, _data_->_tmp346_, _data_->_tmp347_, online_accounts_imap_dialog_save_configuration_ready, _data_);
	return FALSE;
	_state_12:
	e_source_registry_commit_source_finish (_data_->_tmp345_, _data_->_res_, &_data_->_inner_error0_);
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_error_free0 (_data_->smtp_auth_error);
		(_data_->smtp_auth_types == NULL) ? NULL : (_data_->smtp_auth_types = (g_list_free (_data_->smtp_auth_types), NULL));
		_g_object_unref0 (_data_->transport_service);
		_g_error_free0 (_data_->imap_auth_error);
		(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
		_g_object_unref0 (_data_->imap_service);
		_g_object_unref0 (_data_->transport_source);
		_g_object_unref0 (_data_->identity_source);
		_g_object_unref0 (_data_->account_source);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_error_free0 (_data_->smtp_auth_error);
	(_data_->smtp_auth_types == NULL) ? NULL : (_data_->smtp_auth_types = (g_list_free (_data_->smtp_auth_types), NULL));
	_g_object_unref0 (_data_->transport_service);
	_g_error_free0 (_data_->imap_auth_error);
	(_data_->imap_auth_types == NULL) ? NULL : (_data_->imap_auth_types = (g_list_free (_data_->imap_auth_types), NULL));
	_g_object_unref0 (_data_->imap_service);
	_g_object_unref0 (_data_->transport_source);
	_g_object_unref0 (_data_->identity_source);
	_g_object_unref0 (_data_->account_source);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		OnlineAccountsImapDialog* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->cancellable);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static gboolean
__lambda25_ (Block5Data* _data5_)
{
	OnlineAccountsImapDialog* self;
	gboolean result;
	self = _data5_->self;
	self->priv->cancel_timeout_id = (guint) 0;
	g_cancellable_cancel (_data5_->cancellable);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda25__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda25_ (self);
	return result;
}

static void
online_accounts_imap_dialog_set_cancel_timeout (OnlineAccountsImapDialog* self,
                                                GCancellable* cancellable)
{
	Block5Data* _data5_;
	GCancellable* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cancellable != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data5_->cancellable);
	_data5_->cancellable = _tmp0_;
	self->priv->cancel_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 4000, ___lambda25__gsource_func, block5_data_ref (_data5_), block5_data_unref);
	block5_data_unref (_data5_);
	_data5_ = NULL;
}

static void
online_accounts_imap_dialog_unset_cancel_timeout (OnlineAccountsImapDialog* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->cancel_timeout_id != ((guint) 0)) {
		g_source_remove (self->priv->cancel_timeout_id);
	}
}

OnlineAccountsImapDialog*
online_accounts_imap_dialog_construct (GType object_type)
{
	OnlineAccountsImapDialog * self = NULL;
	self = (OnlineAccountsImapDialog*) g_object_new (object_type, NULL);
	return self;
}

OnlineAccountsImapDialog*
online_accounts_imap_dialog_new (void)
{
	return online_accounts_imap_dialog_construct (ONLINE_ACCOUNTS_TYPE_IMAP_DIALOG);
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		OnlineAccountsImapDialog* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->deck);
		_g_object_unref0 (_data6_->main_grid);
		_g_object_unref0 (_data6_->smtp_revealer);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static void
_gtk_widget_destroy_online_accounts_imap_login_page_cancel (OnlineAccountsImapLoginPage* _sender,
                                                            gpointer self)
{
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
_online_accounts_imap_dialog___lambda26_ (Block6Data* _data6_)
{
	OnlineAccountsImapDialog* self;
	HdyDeck* _tmp0_;
	GtkGrid* _tmp1_;
	GtkButton* _tmp2_;
	self = _data6_->self;
	_tmp0_ = _data6_->deck;
	_tmp1_ = _data6_->main_grid;
	hdy_deck_set_visible_child (_tmp0_, (GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->save_button;
	g_object_set ((GtkWidget*) _tmp2_, "has-default", TRUE, NULL);
}

static void
__online_accounts_imap_dialog___lambda26__gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
	_online_accounts_imap_dialog___lambda26_ (self);
}

static void
_gtk_widget_destroy_online_accounts_imap_save_page_close (OnlineAccountsImapSavePage* _sender,
                                                          gpointer self)
{
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
_online_accounts_imap_dialog___lambda27_ (Block6Data* _data6_)
{
	OnlineAccountsImapDialog* self;
	HdyDeck* _tmp0_;
	GtkButton* _tmp1_;
	self = _data6_->self;
	_tmp0_ = _data6_->deck;
	hdy_deck_navigate (_tmp0_, HDY_NAVIGATION_DIRECTION_BACK);
	_tmp1_ = self->priv->save_button;
	g_object_set ((GtkWidget*) _tmp1_, "has-default", TRUE, NULL);
}

static void
__online_accounts_imap_dialog___lambda27__online_accounts_imap_save_page_back (OnlineAccountsImapSavePage* _sender,
                                                                               gpointer self)
{
	_online_accounts_imap_dialog___lambda27_ (self);
}

static void
_online_accounts_imap_dialog___lambda28_ (Block6Data* _data6_)
{
	OnlineAccountsImapDialog* self;
	HdyDeck* _tmp0_;
	OnlineAccountsImapLoginPage* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	self = _data6_->self;
	_tmp0_ = _data6_->deck;
	hdy_deck_navigate (_tmp0_, HDY_NAVIGATION_DIRECTION_BACK);
	_tmp1_ = self->priv->login_page;
	_tmp2_ = online_accounts_imap_login_page_get_next_button (_tmp1_);
	_tmp3_ = _tmp2_;
	g_object_set ((GtkWidget*) _tmp3_, "has-default", TRUE, NULL);
}

static void
__online_accounts_imap_dialog___lambda28__gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
	_online_accounts_imap_dialog___lambda28_ (self);
}

static void
_online_accounts_imap_dialog___lambda29_ (Block6Data* _data6_)
{
	OnlineAccountsImapDialog* self;
	gboolean _tmp0_ = FALSE;
	GtkCheckButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkRevealer* _tmp7_;
	GtkCheckButton* _tmp8_;
	GtkCheckButton* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	self = _data6_->self;
	_tmp1_ = self->priv->smtp_no_credentials;
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		GtkCheckButton* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->use_imap_credentials;
		_tmp5_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = !_tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp7_ = _data6_->smtp_revealer;
	gtk_revealer_set_reveal_child (_tmp7_, _tmp0_);
	_tmp8_ = self->priv->use_imap_credentials;
	_tmp9_ = self->priv->smtp_no_credentials;
	_tmp10_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp9_);
	_tmp11_ = _tmp10_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, !_tmp11_);
}

static void
__online_accounts_imap_dialog___lambda29__g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
	_online_accounts_imap_dialog___lambda29_ (self);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
_online_accounts_imap_dialog___lambda30_ (OnlineAccountsImapDialog* self)
{
	OnlineAccountsImapLoginPage* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->priv->login_page;
	_tmp1_ = online_accounts_imap_login_page_get_email (_tmp0_);
	_tmp2_ = _tmp1_;
	if (string_contains (_tmp2_, "@")) {
		gchar* domain = NULL;
		OnlineAccountsImapLoginPage* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		GraniteValidatedEntry* _tmp25_;
		OnlineAccountsImapLoginPage* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		GtkEntry* _tmp29_;
		OnlineAccountsImapLoginPage* _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		_tmp3_ = self->priv->login_page;
		_tmp4_ = online_accounts_imap_login_page_get_email (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "@", 2);
		_tmp8_ = _tmp7_;
		_tmp8__length1 = _vala_array_length (_tmp6_);
		_tmp9_ = _tmp8_[1];
		_tmp10_ = string_strip (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = string_replace (_tmp11_, "@", "");
		_tmp13_ = _tmp12_;
		_g_free0 (_tmp11_);
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
		domain = _tmp13_;
		_tmp14_ = domain;
		_tmp15_ = strlen (_tmp14_);
		_tmp16_ = _tmp15_;
		if (_tmp16_ > 0) {
			GraniteValidatedEntry* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			GraniteValidatedEntry* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			_tmp17_ = self->priv->imap_server_entry;
			_tmp18_ = domain;
			_tmp19_ = g_strconcat ("imap.", _tmp18_, NULL);
			_tmp20_ = _tmp19_;
			gtk_entry_set_text ((GtkEntry*) _tmp17_, _tmp20_);
			_g_free0 (_tmp20_);
			_tmp21_ = self->priv->smtp_server_entry;
			_tmp22_ = domain;
			_tmp23_ = g_strconcat ("smtp.", _tmp22_, NULL);
			_tmp24_ = _tmp23_;
			gtk_entry_set_text ((GtkEntry*) _tmp21_, _tmp24_);
			_g_free0 (_tmp24_);
		}
		_tmp25_ = self->priv->imap_username_entry;
		_tmp26_ = self->priv->login_page;
		_tmp27_ = online_accounts_imap_login_page_get_email (_tmp26_);
		_tmp28_ = _tmp27_;
		gtk_entry_set_text ((GtkEntry*) _tmp25_, _tmp28_);
		_tmp29_ = self->priv->smtp_username_entry;
		_tmp30_ = self->priv->login_page;
		_tmp31_ = online_accounts_imap_login_page_get_email (_tmp30_);
		_tmp32_ = _tmp31_;
		gtk_entry_set_text (_tmp29_, _tmp32_);
		_g_free0 (domain);
	}
	online_accounts_imap_dialog_set_button_sensitivity (self);
}

static void
__online_accounts_imap_dialog___lambda30__g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
	_online_accounts_imap_dialog___lambda30_ ((OnlineAccountsImapDialog*) self);
}

static void
_online_accounts_imap_dialog___lambda31_ (OnlineAccountsImapDialog* self)
{
	GraniteValidatedEntry* _tmp0_;
	GraniteValidatedEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	_tmp0_ = self->priv->imap_username_entry;
	_tmp1_ = self->priv->imap_username_entry;
	_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	granite_validated_entry_set_is_valid (_tmp0_, _tmp5_ > 0);
	online_accounts_imap_dialog_set_button_sensitivity (self);
}

static void
__online_accounts_imap_dialog___lambda31__gtk_editable_changed (GtkEditable* _sender,
                                                                gpointer self)
{
	_online_accounts_imap_dialog___lambda31_ ((OnlineAccountsImapDialog*) self);
}

static void
_online_accounts_imap_dialog___lambda32_ (OnlineAccountsImapDialog* self)
{
	GraniteValidatedEntry* _tmp0_;
	GraniteValidatedEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	_tmp0_ = self->priv->imap_server_entry;
	_tmp1_ = self->priv->imap_server_entry;
	_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	granite_validated_entry_set_is_valid (_tmp0_, _tmp5_ > 3);
	online_accounts_imap_dialog_set_button_sensitivity (self);
}

static void
__online_accounts_imap_dialog___lambda32__gtk_editable_changed (GtkEditable* _sender,
                                                                gpointer self)
{
	_online_accounts_imap_dialog___lambda32_ ((OnlineAccountsImapDialog*) self);
}

static void
_online_accounts_imap_dialog___lambda33_ (OnlineAccountsImapDialog* self)
{
	GtkComboBoxText* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	_tmp0_ = self->priv->imap_encryption_combobox;
	_tmp1_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case 1:
		{
			GtkSpinButton* _tmp3_;
			_tmp3_ = self->priv->imap_port_spin;
			gtk_spin_button_set_value (_tmp3_, (gdouble) 993);
			break;
		}
		case 2:
		{
			GtkSpinButton* _tmp4_;
			_tmp4_ = self->priv->imap_port_spin;
			gtk_spin_button_set_value (_tmp4_, (gdouble) 143);
			break;
		}
		default:
		{
			GtkSpinButton* _tmp5_;
			_tmp5_ = self->priv->imap_port_spin;
			gtk_spin_button_set_value (_tmp5_, (gdouble) 143);
			break;
		}
	}
}

static void
__online_accounts_imap_dialog___lambda33__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self)
{
	_online_accounts_imap_dialog___lambda33_ ((OnlineAccountsImapDialog*) self);
}

static void
_online_accounts_imap_dialog___lambda34_ (OnlineAccountsImapDialog* self)
{
	GraniteValidatedEntry* _tmp0_;
	GraniteValidatedEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	_tmp0_ = self->priv->smtp_server_entry;
	_tmp1_ = self->priv->smtp_server_entry;
	_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	granite_validated_entry_set_is_valid (_tmp0_, _tmp5_ > 3);
	online_accounts_imap_dialog_set_button_sensitivity (self);
}

static void
__online_accounts_imap_dialog___lambda34__gtk_editable_changed (GtkEditable* _sender,
                                                                gpointer self)
{
	_online_accounts_imap_dialog___lambda34_ ((OnlineAccountsImapDialog*) self);
}

static void
_online_accounts_imap_dialog___lambda35_ (OnlineAccountsImapDialog* self)
{
	GtkComboBoxText* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	_tmp0_ = self->priv->smtp_encryption_combobox;
	_tmp1_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case 1:
		{
			GtkSpinButton* _tmp3_;
			_tmp3_ = self->priv->smtp_port_spin;
			gtk_spin_button_set_value (_tmp3_, (gdouble) 465);
			break;
		}
		case 2:
		{
			GtkSpinButton* _tmp4_;
			_tmp4_ = self->priv->smtp_port_spin;
			gtk_spin_button_set_value (_tmp4_, (gdouble) 587);
			break;
		}
		default:
		{
			GtkSpinButton* _tmp5_;
			_tmp5_ = self->priv->smtp_port_spin;
			gtk_spin_button_set_value (_tmp5_, (gdouble) 25);
			break;
		}
	}
}

static void
__online_accounts_imap_dialog___lambda35__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self)
{
	_online_accounts_imap_dialog___lambda35_ ((OnlineAccountsImapDialog*) self);
}

static void
__lambda37_ (OnlineAccountsImapDialog* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		OnlineAccountsImapSavePage* _tmp0_;
		online_accounts_imap_dialog_save_configuration_finish (self, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp0_ = self->priv->save_page;
		online_accounts_imap_save_page_show_success (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		OnlineAccountsImapSavePage* _tmp1_;
		GError* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = self->priv->save_page;
		_tmp2_ = e;
		online_accounts_imap_save_page_show_error (_tmp1_, _tmp2_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda37__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda37_ ((OnlineAccountsImapDialog*) self, source_object, res);
	g_object_unref (self);
}

static void
_online_accounts_imap_dialog___lambda36_ (Block6Data* _data6_)
{
	OnlineAccountsImapDialog* self;
	GCancellable* _tmp0_;
	GCancellable* _tmp2_;
	HdyDeck* _tmp3_;
	OnlineAccountsImapSavePage* _tmp4_;
	OnlineAccountsImapSavePage* _tmp5_;
	GCancellable* _tmp6_;
	self = _data6_->self;
	_tmp0_ = self->priv->cancellable;
	if (_tmp0_ != NULL) {
		GCancellable* _tmp1_;
		_tmp1_ = self->priv->cancellable;
		g_cancellable_cancel (_tmp1_);
	}
	_tmp2_ = g_cancellable_new ();
	_g_object_unref0 (self->priv->cancellable);
	self->priv->cancellable = _tmp2_;
	_tmp3_ = _data6_->deck;
	_tmp4_ = self->priv->save_page;
	hdy_deck_set_visible_child (_tmp3_, (GtkWidget*) _tmp4_);
	_tmp5_ = self->priv->save_page;
	_tmp6_ = self->priv->cancellable;
	online_accounts_imap_save_page_show_busy (_tmp5_, _tmp6_);
	online_accounts_imap_dialog_save_configuration (self, ___lambda37__gasync_ready_callback, g_object_ref (self));
}

static void
__online_accounts_imap_dialog___lambda36__gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
	_online_accounts_imap_dialog___lambda36_ (self);
}

static gboolean
_online_accounts_imap_dialog___lambda38_ (OnlineAccountsImapDialog* self,
                                          GdkEventKey* event_key)
{
	g_return_val_if_fail (event_key != NULL, FALSE);
	if (event_key->keyval == GDK_KEY_Escape) {
		GCancellable* _tmp0_;
		_tmp0_ = self->priv->cancellable;
		if (_tmp0_ != NULL) {
			GCancellable* _tmp1_;
			_tmp1_ = self->priv->cancellable;
			g_cancellable_cancel (_tmp1_);
		}
		gtk_widget_destroy ((GtkWidget*) self);
	}
}

static gboolean
__online_accounts_imap_dialog___lambda38__gtk_widget_key_release_event (GtkWidget* _sender,
                                                                        GdkEventKey* event,
                                                                        gpointer self)
{
	gboolean result;
	result = _online_accounts_imap_dialog___lambda38_ ((OnlineAccountsImapDialog*) self, event);
	return result;
}

static GObject *
online_accounts_imap_dialog_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	OnlineAccountsImapDialog * self;
	Block6Data* _data6_;
	OnlineAccountsImapLoginPage* _tmp0_;
	OnlineAccountsImapSavePage* _tmp1_;
	GraniteHeaderLabel* imap_header = NULL;
	GraniteHeaderLabel* _tmp2_;
	GtkLabel* imap_username_label = NULL;
	GtkLabel* _tmp3_ = NULL;
	GraniteValidatedEntry* _tmp4_ = NULL;
	GtkLabel* imap_password_label = NULL;
	GtkLabel* _tmp5_ = NULL;
	GtkLabel* imap_url_label = NULL;
	GtkLabel* _tmp6_ = NULL;
	GraniteValidatedEntry* _tmp7_;
	GtkSpinButton* _tmp8_ = NULL;
	GtkLabel* imap_port_label = NULL;
	GtkLabel* _tmp9_ = NULL;
	GtkLabel* imap_encryption_label = NULL;
	GtkLabel* _tmp10_ = NULL;
	GtkComboBoxText* _tmp11_ = NULL;
	GtkComboBoxText* _tmp12_;
	GtkComboBoxText* _tmp13_;
	GtkComboBoxText* _tmp14_;
	GtkComboBoxText* _tmp15_;
	GtkGrid* imap_server_grid = NULL;
	GtkGrid* _tmp16_ = NULL;
	GtkGrid* _tmp17_;
	GraniteHeaderLabel* _tmp18_;
	GtkGrid* _tmp19_;
	GtkLabel* _tmp20_;
	GtkGrid* _tmp21_;
	GraniteValidatedEntry* _tmp22_;
	GtkGrid* _tmp23_;
	GtkLabel* _tmp24_;
	GtkGrid* _tmp25_;
	GraniteValidatedEntry* _tmp26_;
	GtkGrid* _tmp27_;
	GtkLabel* _tmp28_;
	GtkGrid* _tmp29_;
	GtkComboBoxText* _tmp30_;
	GtkGrid* _tmp31_;
	GtkLabel* _tmp32_;
	GtkGrid* _tmp33_;
	GtkSpinButton* _tmp34_;
	GtkCheckButton* _tmp35_ = NULL;
	GtkCheckButton* _tmp36_;
	GraniteHeaderLabel* smtp_header = NULL;
	GraniteHeaderLabel* _tmp37_;
	GtkLabel* smtp_username_label = NULL;
	GtkLabel* _tmp38_ = NULL;
	GtkEntry* _tmp39_ = NULL;
	GtkLabel* smtp_password_label = NULL;
	GtkLabel* _tmp40_ = NULL;
	GtkEntry* _tmp41_ = NULL;
	GtkGrid* smtp_credentials = NULL;
	GtkGrid* _tmp42_ = NULL;
	GtkGrid* _tmp43_;
	GtkLabel* _tmp44_;
	GtkGrid* _tmp45_;
	GtkEntry* _tmp46_;
	GtkGrid* _tmp47_;
	GtkLabel* _tmp48_;
	GtkGrid* _tmp49_;
	GtkEntry* _tmp50_;
	GtkRevealer* _tmp51_;
	GtkRevealer* _tmp52_;
	GtkGrid* _tmp53_;
	GtkLabel* smtp_url_label = NULL;
	GtkLabel* _tmp54_ = NULL;
	GraniteValidatedEntry* _tmp55_;
	GtkLabel* smtp_port_label = NULL;
	GtkLabel* _tmp56_ = NULL;
	GtkSpinButton* _tmp57_ = NULL;
	GtkLabel* smtp_encryption_label = NULL;
	GtkLabel* _tmp58_ = NULL;
	GtkComboBoxText* _tmp59_ = NULL;
	GtkComboBoxText* _tmp60_;
	GtkComboBoxText* _tmp61_;
	GtkComboBoxText* _tmp62_;
	GtkComboBoxText* _tmp63_;
	GtkGrid* smtp_server_grid = NULL;
	GtkGrid* _tmp64_ = NULL;
	GtkGrid* _tmp65_;
	GraniteHeaderLabel* _tmp66_;
	GtkGrid* _tmp67_;
	GtkCheckButton* _tmp68_;
	GtkGrid* _tmp69_;
	GtkCheckButton* _tmp70_;
	GtkGrid* _tmp71_;
	GtkRevealer* _tmp72_;
	GtkGrid* _tmp73_;
	GtkLabel* _tmp74_;
	GtkGrid* _tmp75_;
	GraniteValidatedEntry* _tmp76_;
	GtkGrid* _tmp77_;
	GtkLabel* _tmp78_;
	GtkGrid* _tmp79_;
	GtkComboBoxText* _tmp80_;
	GtkGrid* _tmp81_;
	GtkLabel* _tmp82_;
	GtkGrid* _tmp83_;
	GtkSpinButton* _tmp84_;
	GtkSizeGroup* smtp_sizegroup = NULL;
	GtkSizeGroup* _tmp85_;
	GtkSizeGroup* _tmp86_;
	GtkLabel* _tmp87_;
	GtkSizeGroup* _tmp88_;
	GtkLabel* _tmp89_;
	GtkSizeGroup* _tmp90_;
	GtkLabel* _tmp91_;
	GtkSizeGroup* _tmp92_;
	GtkLabel* _tmp93_;
	GtkSizeGroup* _tmp94_;
	GtkLabel* _tmp95_;
	GtkButton* back_button = NULL;
	GtkButton* _tmp96_;
	GtkButton* _tmp97_ = NULL;
	GtkButton* _tmp98_;
	GtkStyleContext* _tmp99_;
	GtkButtonBox* action_area = NULL;
	GtkButtonBox* _tmp100_ = NULL;
	GtkButtonBox* _tmp101_;
	GtkButton* _tmp102_;
	GtkButtonBox* _tmp103_;
	GtkButton* _tmp104_;
	GtkGrid* _tmp105_ = NULL;
	GtkGrid* _tmp106_;
	GtkGrid* _tmp107_;
	GtkGrid* _tmp108_;
	GtkGrid* _tmp109_;
	GtkGrid* _tmp110_;
	GtkButtonBox* _tmp111_;
	HdyDeck* _tmp112_ = NULL;
	HdyDeck* _tmp113_;
	OnlineAccountsImapLoginPage* _tmp114_;
	HdyDeck* _tmp115_;
	GtkGrid* _tmp116_;
	HdyDeck* _tmp117_;
	OnlineAccountsImapSavePage* _tmp118_;
	HdyWindowHandle* window_handle = NULL;
	HdyWindowHandle* _tmp119_;
	HdyWindowHandle* _tmp120_;
	HdyDeck* _tmp121_;
	HdyWindowHandle* _tmp122_;
	OnlineAccountsImapLoginPage* _tmp123_;
	GtkButton* _tmp124_;
	GtkButton* _tmp125_;
	OnlineAccountsImapLoginPage* _tmp126_;
	OnlineAccountsImapLoginPage* _tmp127_;
	GtkButton* _tmp128_;
	GtkButton* _tmp129_;
	OnlineAccountsImapSavePage* _tmp130_;
	OnlineAccountsImapSavePage* _tmp131_;
	GtkButton* _tmp132_;
	GtkCheckButton* _tmp133_;
	GtkCheckButton* _tmp134_;
	GtkRevealer* _tmp135_;
	OnlineAccountsImapLoginPage* _tmp136_;
	GraniteValidatedEntry* _tmp137_;
	GraniteValidatedEntry* _tmp138_;
	GtkComboBoxText* _tmp139_;
	GraniteValidatedEntry* _tmp140_;
	GtkComboBoxText* _tmp141_;
	GtkButton* _tmp142_;
	parent_class = G_OBJECT_CLASS (online_accounts_imap_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_IMAP_DIALOG, OnlineAccountsImapDialog);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = online_accounts_imap_login_page_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->login_page);
	self->priv->login_page = _tmp0_;
	_tmp1_ = online_accounts_imap_save_page_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->save_page);
	self->priv->save_page = _tmp1_;
	_tmp2_ = granite_header_label_new ("IMAP");
	g_object_ref_sink (_tmp2_);
	imap_header = _tmp2_;
	_tmp3_ = (GtkLabel*) gtk_label_new (_ ("Username:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp3_);
	imap_username_label = _tmp3_;
	_tmp4_ = granite_validated_entry_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp4_, TRUE);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->imap_username_entry);
	self->priv->imap_username_entry = _tmp4_;
	_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Password:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_END);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp5_, 18);
	g_object_ref_sink (_tmp5_);
	imap_password_label = _tmp5_;
	_tmp6_ = (GtkLabel*) gtk_label_new (_ ("Server URL:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp6_);
	imap_url_label = _tmp6_;
	_tmp7_ = granite_validated_entry_new ();
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->imap_server_entry);
	self->priv->imap_server_entry = _tmp7_;
	_tmp8_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) G_MAXUINT16, (gdouble) 10);
	gtk_spin_button_set_value (_tmp8_, (gdouble) 993);
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->imap_port_spin);
	self->priv->imap_port_spin = _tmp8_;
	_tmp9_ = (GtkLabel*) gtk_label_new (_ ("Port:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp9_);
	imap_port_label = _tmp9_;
	_tmp10_ = (GtkLabel*) gtk_label_new (_ ("Encryption:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp10_);
	imap_encryption_label = _tmp10_;
	_tmp11_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp11_, TRUE);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->imap_encryption_combobox);
	self->priv->imap_encryption_combobox = _tmp11_;
	_tmp12_ = self->priv->imap_encryption_combobox;
	gtk_combo_box_text_append (_tmp12_, "none", _ ("None"));
	_tmp13_ = self->priv->imap_encryption_combobox;
	gtk_combo_box_text_append (_tmp13_, "ssl-on-alternate-port", "SSL/TLS");
	_tmp14_ = self->priv->imap_encryption_combobox;
	gtk_combo_box_text_append (_tmp14_, "starttls-on-standard-port", "STARTTLS");
	_tmp15_ = self->priv->imap_encryption_combobox;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp15_, 1);
	_tmp16_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp16_, 6);
	gtk_grid_set_row_spacing (_tmp16_, 6);
	g_object_ref_sink (_tmp16_);
	imap_server_grid = _tmp16_;
	_tmp17_ = imap_server_grid;
	_tmp18_ = imap_header;
	gtk_grid_attach (_tmp17_, (GtkWidget*) _tmp18_, 0, 0, 2, 1);
	_tmp19_ = imap_server_grid;
	_tmp20_ = imap_username_label;
	gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp20_, 0, 1, 1, 1);
	_tmp21_ = imap_server_grid;
	_tmp22_ = self->priv->imap_username_entry;
	gtk_grid_attach (_tmp21_, (GtkWidget*) _tmp22_, 1, 1, 1, 1);
	_tmp23_ = imap_server_grid;
	_tmp24_ = imap_url_label;
	gtk_grid_attach (_tmp23_, (GtkWidget*) _tmp24_, 0, 3, 1, 1);
	_tmp25_ = imap_server_grid;
	_tmp26_ = self->priv->imap_server_entry;
	gtk_grid_attach (_tmp25_, (GtkWidget*) _tmp26_, 1, 3, 1, 1);
	_tmp27_ = imap_server_grid;
	_tmp28_ = imap_encryption_label;
	gtk_grid_attach (_tmp27_, (GtkWidget*) _tmp28_, 0, 4, 1, 1);
	_tmp29_ = imap_server_grid;
	_tmp30_ = self->priv->imap_encryption_combobox;
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 1, 4, 1, 1);
	_tmp31_ = imap_server_grid;
	_tmp32_ = imap_port_label;
	gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp32_, 0, 5, 1, 1);
	_tmp33_ = imap_server_grid;
	_tmp34_ = self->priv->imap_port_spin;
	gtk_grid_attach (_tmp33_, (GtkWidget*) _tmp34_, 1, 5, 1, 1);
	_tmp35_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Use IMAP Credentials"));
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp35_, TRUE);
	g_object_ref_sink (_tmp35_);
	_g_object_unref0 (self->priv->use_imap_credentials);
	self->priv->use_imap_credentials = _tmp35_;
	_tmp36_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("No authentication required"));
	g_object_ref_sink (_tmp36_);
	_g_object_unref0 (self->priv->smtp_no_credentials);
	self->priv->smtp_no_credentials = _tmp36_;
	_tmp37_ = granite_header_label_new ("SMTP");
	g_object_ref_sink (_tmp37_);
	smtp_header = _tmp37_;
	_tmp38_ = (GtkLabel*) gtk_label_new (_ ("Username:"));
	gtk_label_set_xalign (_tmp38_, (gfloat) 1);
	g_object_ref_sink (_tmp38_);
	smtp_username_label = _tmp38_;
	_tmp39_ = (GtkEntry*) gtk_entry_new ();
	gtk_entry_set_activates_default (_tmp39_, TRUE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp39_, TRUE);
	g_object_ref_sink (_tmp39_);
	_g_object_unref0 (self->priv->smtp_username_entry);
	self->priv->smtp_username_entry = _tmp39_;
	_tmp40_ = (GtkLabel*) gtk_label_new (_ ("Password:"));
	gtk_label_set_xalign (_tmp40_, (gfloat) 1);
	g_object_ref_sink (_tmp40_);
	smtp_password_label = _tmp40_;
	_tmp41_ = (GtkEntry*) gtk_entry_new ();
	gtk_entry_set_activates_default (_tmp41_, TRUE);
	gtk_entry_set_input_purpose (_tmp41_, GTK_INPUT_PURPOSE_PASSWORD);
	gtk_entry_set_visibility (_tmp41_, FALSE);
	g_object_ref_sink (_tmp41_);
	_g_object_unref0 (self->priv->smtp_password_entry);
	self->priv->smtp_password_entry = _tmp41_;
	_tmp42_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp42_, 6);
	gtk_grid_set_row_spacing (_tmp42_, 6);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp42_, 18);
	g_object_ref_sink (_tmp42_);
	smtp_credentials = _tmp42_;
	_tmp43_ = smtp_credentials;
	_tmp44_ = smtp_username_label;
	gtk_grid_attach (_tmp43_, (GtkWidget*) _tmp44_, 0, 0, 1, 1);
	_tmp45_ = smtp_credentials;
	_tmp46_ = self->priv->smtp_username_entry;
	gtk_grid_attach (_tmp45_, (GtkWidget*) _tmp46_, 1, 0, 1, 1);
	_tmp47_ = smtp_credentials;
	_tmp48_ = smtp_password_label;
	gtk_grid_attach (_tmp47_, (GtkWidget*) _tmp48_, 0, 1, 1, 1);
	_tmp49_ = smtp_credentials;
	_tmp50_ = self->priv->smtp_password_entry;
	gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, 1, 1, 1, 1);
	_tmp51_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp51_);
	_data6_->smtp_revealer = _tmp51_;
	_tmp52_ = _data6_->smtp_revealer;
	_tmp53_ = smtp_credentials;
	gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
	_tmp54_ = (GtkLabel*) gtk_label_new (_ ("Server URL:"));
	gtk_label_set_xalign (_tmp54_, (gfloat) 1);
	g_object_ref_sink (_tmp54_);
	smtp_url_label = _tmp54_;
	_tmp55_ = granite_validated_entry_new ();
	g_object_ref_sink (_tmp55_);
	_g_object_unref0 (self->priv->smtp_server_entry);
	self->priv->smtp_server_entry = _tmp55_;
	_tmp56_ = (GtkLabel*) gtk_label_new (_ ("Port:"));
	gtk_label_set_xalign (_tmp56_, (gfloat) 1);
	g_object_ref_sink (_tmp56_);
	smtp_port_label = _tmp56_;
	_tmp57_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) G_MAXUINT16, (gdouble) 10);
	gtk_spin_button_set_value (_tmp57_, (gdouble) 587);
	g_object_ref_sink (_tmp57_);
	_g_object_unref0 (self->priv->smtp_port_spin);
	self->priv->smtp_port_spin = _tmp57_;
	_tmp58_ = (GtkLabel*) gtk_label_new (_ ("Encryption:"));
	gtk_label_set_xalign (_tmp58_, (gfloat) 1);
	g_object_ref_sink (_tmp58_);
	smtp_encryption_label = _tmp58_;
	_tmp59_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp59_, TRUE);
	g_object_ref_sink (_tmp59_);
	_g_object_unref0 (self->priv->smtp_encryption_combobox);
	self->priv->smtp_encryption_combobox = _tmp59_;
	_tmp60_ = self->priv->smtp_encryption_combobox;
	gtk_combo_box_text_append (_tmp60_, "none", _ ("None"));
	_tmp61_ = self->priv->smtp_encryption_combobox;
	gtk_combo_box_text_append (_tmp61_, "ssl-on-alternate-port", "SSL/TLS");
	_tmp62_ = self->priv->smtp_encryption_combobox;
	gtk_combo_box_text_append (_tmp62_, "starttls-on-standard-port", "STARTTLS");
	_tmp63_ = self->priv->smtp_encryption_combobox;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp63_, 2);
	_tmp64_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp64_, 6);
	gtk_grid_set_row_spacing (_tmp64_, 6);
	g_object_ref_sink (_tmp64_);
	smtp_server_grid = _tmp64_;
	_tmp65_ = smtp_server_grid;
	_tmp66_ = smtp_header;
	gtk_grid_attach (_tmp65_, (GtkWidget*) _tmp66_, 0, 0, 2, 1);
	_tmp67_ = smtp_server_grid;
	_tmp68_ = self->priv->smtp_no_credentials;
	gtk_grid_attach (_tmp67_, (GtkWidget*) _tmp68_, 1, 1, 1, 1);
	_tmp69_ = smtp_server_grid;
	_tmp70_ = self->priv->use_imap_credentials;
	gtk_grid_attach (_tmp69_, (GtkWidget*) _tmp70_, 1, 2, 1, 1);
	_tmp71_ = smtp_server_grid;
	_tmp72_ = _data6_->smtp_revealer;
	gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, 0, 3, 2, 1);
	_tmp73_ = smtp_server_grid;
	_tmp74_ = smtp_url_label;
	gtk_grid_attach (_tmp73_, (GtkWidget*) _tmp74_, 0, 4, 1, 1);
	_tmp75_ = smtp_server_grid;
	_tmp76_ = self->priv->smtp_server_entry;
	gtk_grid_attach (_tmp75_, (GtkWidget*) _tmp76_, 1, 4, 1, 1);
	_tmp77_ = smtp_server_grid;
	_tmp78_ = smtp_encryption_label;
	gtk_grid_attach (_tmp77_, (GtkWidget*) _tmp78_, 0, 5, 1, 1);
	_tmp79_ = smtp_server_grid;
	_tmp80_ = self->priv->smtp_encryption_combobox;
	gtk_grid_attach (_tmp79_, (GtkWidget*) _tmp80_, 1, 5, 1, 1);
	_tmp81_ = smtp_server_grid;
	_tmp82_ = smtp_port_label;
	gtk_grid_attach (_tmp81_, (GtkWidget*) _tmp82_, 0, 6, 1, 1);
	_tmp83_ = smtp_server_grid;
	_tmp84_ = self->priv->smtp_port_spin;
	gtk_grid_attach (_tmp83_, (GtkWidget*) _tmp84_, 1, 6, 1, 1);
	_tmp85_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
	smtp_sizegroup = _tmp85_;
	_tmp86_ = smtp_sizegroup;
	_tmp87_ = smtp_username_label;
	gtk_size_group_add_widget (_tmp86_, (GtkWidget*) _tmp87_);
	_tmp88_ = smtp_sizegroup;
	_tmp89_ = smtp_password_label;
	gtk_size_group_add_widget (_tmp88_, (GtkWidget*) _tmp89_);
	_tmp90_ = smtp_sizegroup;
	_tmp91_ = smtp_url_label;
	gtk_size_group_add_widget (_tmp90_, (GtkWidget*) _tmp91_);
	_tmp92_ = smtp_sizegroup;
	_tmp93_ = smtp_encryption_label;
	gtk_size_group_add_widget (_tmp92_, (GtkWidget*) _tmp93_);
	_tmp94_ = smtp_sizegroup;
	_tmp95_ = smtp_port_label;
	gtk_size_group_add_widget (_tmp94_, (GtkWidget*) _tmp95_);
	_tmp96_ = (GtkButton*) gtk_button_new_with_label (_ ("Back"));
	g_object_ref_sink (_tmp96_);
	back_button = _tmp96_;
	_tmp97_ = (GtkButton*) gtk_button_new_with_label (_ ("Log In"));
	gtk_widget_set_can_default ((GtkWidget*) _tmp97_, TRUE);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp97_, FALSE);
	g_object_ref_sink (_tmp97_);
	_g_object_unref0 (self->priv->save_button);
	self->priv->save_button = _tmp97_;
	_tmp98_ = self->priv->save_button;
	_tmp99_ = gtk_widget_get_style_context ((GtkWidget*) _tmp98_);
	gtk_style_context_add_class (_tmp99_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp100_ = (GtkButtonBox*) gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_set (_tmp100_, "layout-style", GTK_BUTTONBOX_END, NULL);
	gtk_box_set_spacing ((GtkBox*) _tmp100_, 6);
	gtk_widget_set_valign ((GtkWidget*) _tmp100_, GTK_ALIGN_END);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp100_, TRUE);
	g_object_ref_sink (_tmp100_);
	action_area = _tmp100_;
	_tmp101_ = action_area;
	_tmp102_ = back_button;
	gtk_container_add ((GtkContainer*) _tmp101_, (GtkWidget*) _tmp102_);
	_tmp103_ = action_area;
	_tmp104_ = self->priv->save_button;
	gtk_container_add ((GtkContainer*) _tmp103_, (GtkWidget*) _tmp104_);
	_tmp105_ = (GtkGrid*) gtk_grid_new ();
	g_object_set ((GtkWidget*) _tmp105_, "margin", 12, NULL);
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp105_, GTK_ORIENTATION_VERTICAL);
	gtk_grid_set_row_spacing (_tmp105_, 24);
	g_object_ref_sink (_tmp105_);
	_data6_->main_grid = _tmp105_;
	_tmp106_ = _data6_->main_grid;
	_tmp107_ = imap_server_grid;
	gtk_container_add ((GtkContainer*) _tmp106_, (GtkWidget*) _tmp107_);
	_tmp108_ = _data6_->main_grid;
	_tmp109_ = smtp_server_grid;
	gtk_container_add ((GtkContainer*) _tmp108_, (GtkWidget*) _tmp109_);
	_tmp110_ = _data6_->main_grid;
	_tmp111_ = action_area;
	gtk_container_add ((GtkContainer*) _tmp110_, (GtkWidget*) _tmp111_);
	_tmp112_ = (HdyDeck*) hdy_deck_new ();
	hdy_deck_set_can_swipe_back (_tmp112_, TRUE);
	g_object_set ((GtkWidget*) _tmp112_, "expand", TRUE, NULL);
	g_object_ref_sink (_tmp112_);
	_data6_->deck = _tmp112_;
	_tmp113_ = _data6_->deck;
	_tmp114_ = self->priv->login_page;
	gtk_container_add ((GtkContainer*) _tmp113_, (GtkWidget*) _tmp114_);
	_tmp115_ = _data6_->deck;
	_tmp116_ = _data6_->main_grid;
	gtk_container_add ((GtkContainer*) _tmp115_, (GtkWidget*) _tmp116_);
	_tmp117_ = _data6_->deck;
	_tmp118_ = self->priv->save_page;
	gtk_container_add ((GtkContainer*) _tmp117_, (GtkWidget*) _tmp118_);
	_tmp119_ = (HdyWindowHandle*) hdy_window_handle_new ();
	g_object_ref_sink (_tmp119_);
	window_handle = _tmp119_;
	_tmp120_ = window_handle;
	_tmp121_ = _data6_->deck;
	gtk_container_add ((GtkContainer*) _tmp120_, (GtkWidget*) _tmp121_);
	g_object_set ((GtkWindow*) self, "default-height", 400, NULL);
	g_object_set ((GtkWindow*) self, "default-width", 300, NULL);
	g_object_set ((GtkWindow*) self, "window-position", GTK_WIN_POS_CENTER_ON_PARENT, NULL);
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	gtk_window_set_type_hint ((GtkWindow*) self, GDK_WINDOW_TYPE_HINT_DIALOG);
	_tmp122_ = window_handle;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp122_);
	_tmp123_ = self->priv->login_page;
	_tmp124_ = online_accounts_imap_login_page_get_next_button (_tmp123_);
	_tmp125_ = _tmp124_;
	g_object_set ((GtkWidget*) _tmp125_, "has-default", TRUE, NULL);
	_tmp126_ = self->priv->login_page;
	g_signal_connect_object (_tmp126_, "cancel", (GCallback) _gtk_widget_destroy_online_accounts_imap_login_page_cancel, (GtkWidget*) self, 0);
	_tmp127_ = self->priv->login_page;
	_tmp128_ = online_accounts_imap_login_page_get_next_button (_tmp127_);
	_tmp129_ = _tmp128_;
	g_signal_connect_data (_tmp129_, "clicked", (GCallback) __online_accounts_imap_dialog___lambda26__gtk_button_clicked, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	_tmp130_ = self->priv->save_page;
	g_signal_connect_object (_tmp130_, "close", (GCallback) _gtk_widget_destroy_online_accounts_imap_save_page_close, (GtkWidget*) self, 0);
	_tmp131_ = self->priv->save_page;
	g_signal_connect_data (_tmp131_, "back", (GCallback) __online_accounts_imap_dialog___lambda27__online_accounts_imap_save_page_back, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	_tmp132_ = back_button;
	g_signal_connect_data (_tmp132_, "clicked", (GCallback) __online_accounts_imap_dialog___lambda28__gtk_button_clicked, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	_tmp133_ = self->priv->smtp_no_credentials;
	g_signal_connect_data ((GObject*) _tmp133_, "notify::active", (GCallback) __online_accounts_imap_dialog___lambda29__g_object_notify, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	_tmp134_ = self->priv->use_imap_credentials;
	_tmp135_ = _data6_->smtp_revealer;
	g_object_bind_property_with_closures ((GObject*) _tmp134_, "active", (GObject*) _tmp135_, "reveal-child", G_BINDING_INVERT_BOOLEAN, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp136_ = self->priv->login_page;
	g_signal_connect_object ((GObject*) _tmp136_, "notify::email", (GCallback) __online_accounts_imap_dialog___lambda30__g_object_notify, self, 0);
	_tmp137_ = self->priv->imap_username_entry;
	g_signal_connect_object ((GtkEditable*) _tmp137_, "changed", (GCallback) __online_accounts_imap_dialog___lambda31__gtk_editable_changed, self, 0);
	_tmp138_ = self->priv->imap_server_entry;
	g_signal_connect_object ((GtkEditable*) _tmp138_, "changed", (GCallback) __online_accounts_imap_dialog___lambda32__gtk_editable_changed, self, 0);
	_tmp139_ = self->priv->imap_encryption_combobox;
	g_signal_connect_object ((GtkComboBox*) _tmp139_, "changed", (GCallback) __online_accounts_imap_dialog___lambda33__gtk_combo_box_changed, self, 0);
	_tmp140_ = self->priv->smtp_server_entry;
	g_signal_connect_object ((GtkEditable*) _tmp140_, "changed", (GCallback) __online_accounts_imap_dialog___lambda34__gtk_editable_changed, self, 0);
	_tmp141_ = self->priv->smtp_encryption_combobox;
	g_signal_connect_object ((GtkComboBox*) _tmp141_, "changed", (GCallback) __online_accounts_imap_dialog___lambda35__gtk_combo_box_changed, self, 0);
	_tmp142_ = self->priv->save_button;
	g_signal_connect_data (_tmp142_, "clicked", (GCallback) __online_accounts_imap_dialog___lambda36__gtk_button_clicked, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	g_signal_connect_object ((GtkWidget*) self, "key-release-event", (GCallback) __online_accounts_imap_dialog___lambda38__gtk_widget_key_release_event, self, 0);
	_g_object_unref0 (window_handle);
	_g_object_unref0 (action_area);
	_g_object_unref0 (back_button);
	_g_object_unref0 (smtp_sizegroup);
	_g_object_unref0 (smtp_server_grid);
	_g_object_unref0 (smtp_encryption_label);
	_g_object_unref0 (smtp_port_label);
	_g_object_unref0 (smtp_url_label);
	_g_object_unref0 (smtp_credentials);
	_g_object_unref0 (smtp_password_label);
	_g_object_unref0 (smtp_username_label);
	_g_object_unref0 (smtp_header);
	_g_object_unref0 (imap_server_grid);
	_g_object_unref0 (imap_encryption_label);
	_g_object_unref0 (imap_port_label);
	_g_object_unref0 (imap_url_label);
	_g_object_unref0 (imap_password_label);
	_g_object_unref0 (imap_username_label);
	_g_object_unref0 (imap_header);
	block6_data_unref (_data6_);
	_data6_ = NULL;
	return obj;
}

static void
online_accounts_imap_dialog_class_init (OnlineAccountsImapDialogClass * klass,
                                        gpointer klass_data)
{
	online_accounts_imap_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &OnlineAccountsImapDialog_private_offset);
	G_OBJECT_CLASS (klass)->constructor = online_accounts_imap_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = online_accounts_imap_dialog_finalize;
}

static void
online_accounts_imap_dialog_instance_init (OnlineAccountsImapDialog * self,
                                           gpointer klass)
{
	self->priv = online_accounts_imap_dialog_get_instance_private (self);
	self->priv->cancel_timeout_id = (guint) 0;
	self->priv->registry = NULL;
	self->priv->source = NULL;
}

static void
online_accounts_imap_dialog_finalize (GObject * obj)
{
	OnlineAccountsImapDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_IMAP_DIALOG, OnlineAccountsImapDialog);
	_g_object_unref0 (self->priv->cancellable);
	_g_object_unref0 (self->priv->imap_server_entry);
	_g_object_unref0 (self->priv->imap_username_entry);
	_g_object_unref0 (self->priv->smtp_server_entry);
	_g_object_unref0 (self->priv->save_button);
	_g_object_unref0 (self->priv->use_imap_credentials);
	_g_object_unref0 (self->priv->smtp_no_credentials);
	_g_object_unref0 (self->priv->imap_encryption_combobox);
	_g_object_unref0 (self->priv->smtp_encryption_combobox);
	_g_object_unref0 (self->priv->smtp_password_entry);
	_g_object_unref0 (self->priv->smtp_username_entry);
	_g_object_unref0 (self->priv->imap_port_spin);
	_g_object_unref0 (self->priv->smtp_port_spin);
	_g_object_unref0 (self->priv->login_page);
	_g_object_unref0 (self->priv->save_page);
	_g_object_unref0 (self->priv->registry);
	_g_object_unref0 (self->priv->source);
	G_OBJECT_CLASS (online_accounts_imap_dialog_parent_class)->finalize (obj);
}

static GType
online_accounts_imap_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsImapDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_imap_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsImapDialog), 0, (GInstanceInitFunc) online_accounts_imap_dialog_instance_init, NULL };
	GType online_accounts_imap_dialog_type_id;
	online_accounts_imap_dialog_type_id = g_type_register_static (hdy_window_get_type (), "OnlineAccountsImapDialog", &g_define_type_info, 0);
	OnlineAccountsImapDialog_private_offset = g_type_add_instance_private (online_accounts_imap_dialog_type_id, sizeof (OnlineAccountsImapDialogPrivate));
	return online_accounts_imap_dialog_type_id;
}

GType
online_accounts_imap_dialog_get_type (void)
{
	static volatile gsize online_accounts_imap_dialog_type_id__once = 0;
	if (g_once_init_enter (&online_accounts_imap_dialog_type_id__once)) {
		GType online_accounts_imap_dialog_type_id;
		online_accounts_imap_dialog_type_id = online_accounts_imap_dialog_get_type_once ();
		g_once_init_leave (&online_accounts_imap_dialog_type_id__once, online_accounts_imap_dialog_type_id);
	}
	return online_accounts_imap_dialog_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

